SUB AufUnterBer (sm%, MJD#, lambda#, phi#, sphi#, cphi#, sinho#, utrise#, utset#, above%)
  'sm%=1 = Sonne sm%=0 = Mond
  'utrise# = Aufgang Mod. Scalicer Dez.
  'utset# = Untergang Mod. Scalicer Dez.
  'above%=1 = immer sichtbar, above%=0 immer dunkel

 Hour# = 1
 DO
   yminus# = SINALT#(sm%, MJD#, Hour# - 1, lambda#, cphi#, sphi#) - sinho#
   IF yminus# > 0 THEN above% = 1 ELSE above% = 0
   yo# = SINALT#(sm%, MJD#, Hour#, lambda#, cphi#, sphi#) - sinho#
   yplus# = SINALT#(sm%, MJD#, Hour# + 1, lambda#, cphi#, sphi#) - sinho#
   CALL QUAD(yminus#, yo#, yplus#, xe#, ye#, zero1#, zero2#, nz%)

   IF nz% = 1 THEN
     IF yminus# < 0 THEN
       utrise# = Hour# + zero1#
     ELSE
       utset# = Hour# + zero1#
     END IF
   END IF

   IF nz% = 2 THEN
     IF ye# < 0 THEN
       utrise# = Hour# + zero2#
       utset# = Hour# + zero1#
     ELSE
       utrise# = Hour# + zero1#
       utset# = Hour# + zero2#
     END IF
   END IF

   yminus# = yplus#
   Hour# = Hour# + 2
 LOOP UNTIL Hour# = 25 OR (utrise# <> 0 AND utset# <> 0)
END SUB

SUB AufUntergang (Modus%, JD&, Tag%, Monat%, Jahr&, Auf$, Unter$)
 'Modus% 1 = Mond, 2 = Sonne, 3 = Dmmerung brgerlich, 4 = Dmmerung nautisch
 CALL AufUnterDaten(0, lambda#, phi#, Zone#)
 CALL Sommerzeit(Tag%, Monat%, Jahr&, Anfang%, Ende%)
 IF Monat% * 100 + Tag% > Anfang% AND Monat% * 100 + Tag% <= Ende% THEN Zone# = Zone# + 1 'Sommerzeit
 MJD# = JD& - 2400001 - Zone# / 24
 sphi# = SN(phi#)
 cphi# = CS(phi#)
 SELECT CASE Modus%
 CASE 1
   sinho# = SN(8 / 60)  'Mond
   sm% = 0
 CASE 2
   sinho# = SN(-50 / 60)'Sonne
   sm% = 1
 CASE 3
   sinho# = SN(-6)      'Dmmerung brgerlich (-6)
   sm% = 1
 CASE 4
   sinho# = SN(-12)     'Dmmerung nautische (-12))
   sm% = 1
 END SELECT
 CALL AufUnterBer(sm%, MJD#, lambda#, phi#, sphi#, cphi#, sinho#, utrise#, utset#, above%)

 AMinute# = (utrise# - INT(utrise#)) * 60 / 100: IF AMinute# >= .595 THEN AMinute# = 0: utrise# = utrise# + 1
 Aufgang# = INT(utrise#) + AMinute#
 IF Aufgang# <> 0 THEN
   Auf$ = USING$("##.##_ ", Aufgang#)
   REPLACE "." WITH ":" IN Auf$
   IF LEN(LTRIM$(Auf$)) = 5 THEN Auf$ = "0" + LTRIM$(Auf$)
 ELSE
   Auf$ = "--:-- "
 END IF

 UMinute# = (utset# - INT(utset#)) * 60 / 100: IF UMinute# >= .595 THEN UMinute# = 0: utset# = utset# + 1
 Untergang# = INT(utset#) + UMinute#
 IF Untergang# <> 0 THEN
   Unter$ = USING$("##.##", Untergang#)
   REPLACE "." WITH ":" IN Unter$
   IF LEN(LTRIM$(Unter$)) = 4 THEN Unter$ = "0" + LTRIM$(Unter$)
 ELSE
   Unter$ = "--:--"
 END IF

 IF Aufgang# = 0 AND Untergang# = 0 THEN
   IF Modus% = 3 THEN
     IF above% = 1 THEN Auf$ = " immer": Unter$ = " hell" ELSE Auf$ = "immer": Unter$ = " dunkel"
   ELSE
     Unter$ = " sichtbar": IF above% = 1 THEN Auf$ = "im." ELSE Auf$ = "nie"
   END IF
 END IF
END SUB

SUB Finsternis (k#, JDE#, AName%)
  CALL Mondphase_Variablen(k#, t#, 0, e#, m#, m1#, f#, o#)
  IF SN(ABS(f#)) > .36 THEN EXIT SUB
  f1# = f# - .02665 * SN(o#)
  a1# = 299.77 + .107408 * k# - .009173 * t# * t#
  p# = .207 * e# * SN(m#) + .0024 * e# * SN(2 * m#) - .0392 * SN(m1#) + .0116 * SN(2 * m1#) - .0073 * e# * SN(m1# + m#) + .0067 * e# * SN(m1# - m#) + .0118 * SN(2 * f1#)
  q# = 5.2207 - .0048 * e# * CS(m#) + .002 * e# * CS(2 * m#) - .3299 * CS(m1#) - .006 * e# * CS(m1# + m#) + .0041 * e# * CS(m1# - m#)
  g# = (p# * CS(f1#) + q# * SN(f1#)) * (1 - .0048 * CS(ABS(f1#)))
  u# = .0059 + .0046 * e# * CS(m#) - .0182 * CS(m1#) + .0004 * CS(2 * m1#) - .0005 * CS(m# + m1#)
  IF AName% = 1 THEN
    var1# = .4075: var2# = .1721
    IF ABS(g#) > 1.5433 + u# THEN EXIT SUB
    AName% = 7 'partiell
    IF (g# >= -.9972 AND g# <= .9972) OR (ABS(g#) >= .9972 AND ABS(g#) < .9972 + ABS(u#)) THEN
      AName% = 8 'ringfrmig
      IF u# < 0 OR (g# > 0 AND u# >= 0 AND u# <= .0047 AND u# < .00464 * SQR(1 - g# * g#)) THEN AName% = 9 'total
    END IF
  ELSE
    '1.0248 statt 1.0128 um mit Meyers abzustimmen, part. MF am 7.10.87
    var1# = .4065: var2# = .1727
    IF (1.0248 - u# - ABS(g#)) / .545 < 0 THEN EXIT SUB 'Keine Halbschattenfinsternis
    AName% = 5
    IF (1.0128 - u# - ABS(g#)) / .545 > 0 AND (.4678 - u#) * (.4678 - u#) - g# * g# > 0 THEN AName% = 6
  END IF
  JDE# = 2451550.09765# + 29.530588853# * k# + .0001337 * t# * t# - .00000015# * t# * t# * t# + .00000000073# * t# * t# * t# * t# +_
  - var1# * SN(m1#) + var2# * e# * SN(m#) + .0161 * SN(2 * m1#) - .0097 * SN(2 * f1#) + .0073 * e# * SN(m1# - m#) - .005 * e# * SN(m1# + m#) - .0023 * SN(m1# - 2 * f1#) +_
  + .0021 * e# * SN(2 * m#) + .0012 * SN(m1# + 2 * f1#) + .0006 * e# * SN(2 * m1# + m#) - .0004 * SN(3 * m1#) - .0003 * e# * SN(m# + 2 * f1#) + .0003 * SN(a1#) +_
  - .0002 * e# * SN(m# - 2 * f1#) - .0002 * e# * SN(2 * m1# - m#) - .0002 * SN(o#)
END SUB

SUB Jahreszeit (JD&, JDE#, AName%, Modus%)
 'Monat% = Modus% wenn eine bestimmte Jahreszeit gebraucht wird
 CALL JultageGregorian(JD&, Tag%, Monat%, Jahr&)
 IF Jahr& < 0 THEN J& = Jahr& + 1 ELSE J& = Jahr&
 IF Modus% <> 0 THEN Monat% = Modus%
 IF JD& > 2086307 THEN y# = (J& - 2000) / 1000 ELSE y# = J& / 1000  'Nach und vor dem Jahr 1000
 SELECT CASE Monat%
 CASE 3
   IF JD& > 2086307 THEN
     JDEo# = 2451623.80984# + 365242.37404# * y# + .05169 * y# * y# - .00411 * y# * y# * y# - .00057 * y# * y# * y# * y#
   ELSE
     JDEo# = 1721139.29189# + 365242.1374# * y# + .06134 * y# * y# + .00111 * y# * y# * y# - .00071 * y# * y# * y# * y#
   END IF
   AName% = 10
 CASE 6
   IF JD& > 2086307 THEN
     JDEo# = 2451716.56767# + 365241.62603# * y# + .00325 * y# * y# + .00888 * y# * y# * y# - .0003 * y# * y# * y# * y#
   ELSE
     JDEo# = 1721233.25401# + 365241.72562# * y# - .05323 * y# * y# + .00907 * y# * y# * y# + .00025 * y# * y# * y# * y#
   END IF
   AName% = 11
 CASE 9
   IF JD& > 2086307 THEN
     JDEo# = 2451810.21715# + 365242.01767# * y# - .11575 * y# * y# + .00337 * y# * y# * y# + .00078 * y# * y# * y# * y#
   ELSE
     JDEo# = 1721325.70455# + 365242.49558# * y# - .11677 * y# * y# - .00297 * y# * y# * y# + .00074 * y# * y# * y# * y#
   END IF
   AName% = 12
 CASE 12
   IF JD& > 2086307 THEN
     JDEo# = 2451900.05952# + 365242.74049# * y# - .06223 * y# * y# - .00823 * y# * y# * y# + .00032 * y# * y# * y# * y#
   ELSE
     JDEo# = 1721414.39987# + 365242.88257# * y# - .00769 * y# * y# - .00933 * y# * y# * y# - .00006 * y# * y# * y# * y#
   END IF
   AName% = 13
 CASE ELSE
   AName% = 0
   EXIT SUB
 END SELECT

 t# = (JDEo# - 2451545) / 36525
 w# = 35999.373# * t# - 2.47
 dl# = 1 + .0334 * CS(w#) + .0007 * CS(2 * w#)

 s# = 485 * CS(324.96 + 1934.136 * t#) + 203 * CS(337.23 + 32964.467# * t#) + 199 * CS(342.08 + 20.186# * t#) +_
 + 182 * CS(27.85 + 445267.112# * t#) + 156 * CS(73.14 + 45036.886# * t#) + 136 * CS(171.52 + 22518.443# * t#) +_
 + 77 * CS(222.54 + 65928.934# * t#) + 74 * CS(296.72 + 3034.906# * t#) + 70 * CS(243.58 + 9037.513000000001# * t#) +_
 + 58 * CS(119.81 + 33718.147# * t#) + 52 * CS(297.17 + 150.678# * t#) + 50 * CS(21.02 + 2281.226# * t#) +_
 + 45 * CS(247.54 + 29929.562# * t#) + 44 * CS(325.15 + 31555.956# * t#) + 29 * CS(60.93 + 4443.417# * t#) +_
 + 18 * CS(155.12 + 67555.328# * t#) + 17 * CS(288.79 + 4562.452# * t#) + 16 * CS(198.04 + 62894.029# * t#) +_
 + 14 * CS(199.76 + 31436.921# * t#) + 12 * CS(95.39 + 14577.848# * t#) + 12 * CS(287.11 + 31931.756# * t#) +_
 + 12 * CS(320.81 + 34777.259# * t#) + 9 * CS(227.73 + 1222.114# * t#) + 8 * CS(15.45 + 16859.074# * t#)
 JDE# = JDEo# + (.00001 * s#) / dl#
END SUB

SUB JulTageZeit (JDE#, Sekunde%, Minute%, Stunde%, JD&)
 CALL AufUnterDaten(0, lambda#, phi#, Zone#)
 JD& = FIX(JDE# + (Zone# / 24))
 Sek# = JDE# + (Zone# / 24) - JD& + .5
 Stunde% = INT(86400 * (Sek# / 3600))
 Sek# = Sek# - Stunde% * 3600 / 86400
 Minute% = INT(86400 * (Sek# / 60))
 Sek# = Sek# - Minute% * 60 / 86400
 Sekunde% = ROUND(86400 * Sek#, 2)
 CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
 CALL Sommerzeit(Tag%, Monat%, Jahr&, Anfang%, Ende%)
 IF Monat% * 100 + Tag% > Anfang% AND Monat% * 100 + Tag% <= Ende% THEN Stunde% = Stunde% + 1
 IF Stunde% >= 24 THEN Stunde% = Stunde% - 24: JD& = JD& + 1
 IF Stunde% < 0 THEN Stunde% = Stunde% + 24: JD& = JD& - 1
END SUB

SUB Koeffizient(d#, m#, m1#, f#, e#, sl#, sr#, sb#)
 sl# = 0: sr# = 0: sb# = 0
 'RESTORE Koeff
 FOR t% = 1 TO 60
   'READ kd%, km%, km1%, kf%, ks#, kr#
   IF Koeff(2, t%) THEN eh# = e# ^ ABS(Koeff(2, t%)) ELSE eh# = 1
   sl# = sl# + Koeff(5, t%) * SN(Koeff(1, t%) * d# + Koeff(2, t%) * m# + Koeff(3, t%) * m1# + Koeff(4, t%) * f#) * eh#
   sr# = sr# + Koeff(6, t%) * CS(Koeff(1, t%) * d# + Koeff(2, t%) * m# + Koeff(3, t%) * m1# + Koeff(4, t%) * f#) * eh#
 NEXT t%
 'RESTORE Koeff1
 FOR t% = 61 TO 120
   'READ kd%, km%, km1%, kf%, kb#
   IF Koeff(2, t%) THEN eh# = e# ^ ABS(Koeff(2, t%)) ELSE eh# = 1
   sb# = sb# + Koeff(5, t%) * SN(Koeff(1, t%) * d# + Koeff(2, t%) * m# + Koeff(3, t%) * m1# + Koeff(4, t%) * f#) * eh#
 NEXT t%
END SUB

SUB KreisGradMin (Winkel#, Minu%, Sek#)
 a# = (Winkel# - FIX(Winkel#)) * 60
 Minu% = FIX(a#)
 Sek# = (a# - Minu%) * 60
END SUB

SUB MiniMoon(t#, ra#, dec#)
 p2# = 6.283185307#: arc# = 206264.8062#: coseps# = .91748: sineps# = .39778
 lo# = FRAK#(.606433 + 1336.855225# * t#)
 l# = p2# * FRAK#(.374897 + 1325.55241# * t#)
 ls# = p2# * FRAK#(.993133 + 99.997361# * t#)
 d# = p2# * FRAK#(.827361 + 1236.853086# * t#)
 f# = p2# * FRAK#(.259086 + 1342.227825# * t#)
 dl# = 22640 * SIN(l#) - 4586 * SIN(l# - 2 * d#) + 2370 * SIN(2 * d#) + 769 * SIN(2 * l#) - 668 * SIN(ls#) - 412 * SIN(2 * f#) - 212 * SIN(2 * l# - 2 * d#) - 206 * SIN(l# + ls# - 2 * d#) +_
 + 192 * SIN(l# + 2 * d#) - 165 * SIN(ls# - 2 * d#) - 125 * SIN(d#) - 110 * SIN(l# + ls#) + 148 * SIN(l# - ls#) - 55 * SIN(2 * f# - 2 * d#)
 s# = f# + (dl# + 412 * SIN(2 * f#) + 541 * SIN(ls#)) / arc#
 h# = f# - 2 * d#
 n# = -526 * SIN(h#) + 44 * SIN(l# + h#) - 31 * SIN(-l# + h#) - 23 * SIN(ls# + h#) + 11 * SIN(-ls# + h#) - 25 * SIN(-2 * l# + f#) + 21 * SIN(-l# + f#)
 lmoon# = p2# * FRAK#(lo# + dl# / 1296000)
 bmoon# = (18520 * SIN(s#) + n#) / arc#
 cb# = COS(bmoon#)
 x# = cb# * COS(lmoon#)
 v# = cb# * SIN(lmoon#)
 w# = SIN(bmoon#)
 y# = coseps# * v# - sineps# * w#
 z# = sineps# * v# + coseps# * w#
 rho# = SQR(1 - z# * z#)
 dec# = (360 / p2#) * ATN(z# / rho#)
 ra# = (48 / p2#) * ATN(y# / (x# + rho#)): IF ra# < 0 THEN ra# = ra# + 24
END SUB

SUB MiniSun(t#, ra#, dec#)
 p2# = 6.283185307#: coseps# = .91748: sineps# = .39778
 m# = p2# * FRAK#(.993133 + 99.997361# * t#)
 dl# = 6893 * SIN(m#) + 72 * SIN(2 * m#)
 l# = p2# * FRAK#(.7859453 + m# / p2# + (6191.2 * t# + dl#) / 1296000#)
 sl# = SIN(l#)
 x# = COS(l#)
 y# = coseps# * sl#
 z# = sineps# * sl#
 rho# = SQR(1 - z# * z#)
 dec# = (360 / p2#) * ATN(z# / rho#)
 ra# = (48 / p2#) * ATN(y# / (x# + rho#)): IF ra# < 0 THEN ra# = ra# + 24
END SUB

SUB Mondbahn(JDE#, Laenge#, Hoehe#, Entfernung#, Teil#)
 t# = (JDE# - 2451545) / 36525
 l1# = 218.3164591 + 481267.88134236 * t# - .0013268 * t# ^ 2 + t ^ 3 / 538841 - t# ^ 4 / 65194000
 d# = 297.8502042 + 445267.11151686 * t# - .00163 * t# ^ 2 + t# ^ 3 / 545868 - t# ^ 4 / 113065000
 m# = 357.5291092 + 35999.0502909 * t# - .0001536 * t# ^ 2 + t# ^ 3 / 24490000
 m1# = 134.9634114 + 477198.8676313 * t# + .008997 * t# ^2 + t# ^ 3 / 69699 - t# ^ 4 / 14712000
 f# = 93.2720993 + 483202.0175273 * t# - .0034029 * t# ^ 2  - t# ^ 3 / 3526000 + t# ^ 4 / 863310000
 a1# = 119.75 + 131.849 * t#
 a2# = 53.09 + 479264.29 * t#
 a3# = 313.45 + 481266.484 * t#
 e# = 1 - .002516 * t# - .0000074 * t# ^ 2
 CALL Koeffizient(d#, m#, m1#, f#, e#, sl#, sr#, sb#)
 sl# = sl# + 3958 * SN(a1#) + 1962 * SN(l1# - f#) + 318 * SN(a2#)
 sb# = sb# - 2235 * SN(l1#) + 382 * SN(a3#) + 175 * SN(a1# - f#) + 175 * SN(a1# + f#) + 127 * SN(l1# - m1#) - 115 * SN(l1# + m1#)
 CALL Nutation_Ekliptikneigung(JDE#, df#, 0, 0)
 Laenge# = Kreis(l1# + sl# / 1000000 + df#)
 Hoehe# = Kreis(sb# / 1000000)
 Entfernung# = 385000.56# + sr# / 1000
 i# = 180 - d# - 6.289 * SN(m1#) + 2.1 * SN(m#) - 1.274 * SN(2 * d# - m1#) - .658 * SN(2 * d#) - .241 * SN(2 * m1#) - .110 * SN(d#)
 Teil# = ROUND((1 + CS(i#)) / 2 * 100, 2)
END SUB

$SEGMENT

SUB MondDeklination (JD&, Nord%, JDE#, Dek#)
 CALL JultageJuldatum(JD&, Tag%, Monat%, Jahr&)
 CALL Schaltjahr(Tag%, Monat%, Jahr&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", JDS&, 0)

 IF Jahr& < 0 THEN Jahr& = Jahr& + 1
 k& = FIX(((Jahr& + (JD& - JDS&) / (337 + Monatstage%(2))) - 2000.03) * 13.3686)
 IF JD& > 2451576 THEN k& = k& + 1
 t# = k& / 1336.86
 IF Nord% = 1 THEN
   d# = 152.2029: m# = 14.8591: m1# = 4.6881: f# = 325.8867: JDE# = 2451562.5897#: mt% = 0 'RESTORE MondDekNord
 ELSE
   d# = 345.6676: m# = 1.3951: m1# = 186.21: f# = 145.1633: JDE# = 2451548.9289#: mt% = 81 'RESTORE MondDekSued
 END IF
 d# = d# + 333.0705546# * k& - .0004025 * t# * t# + .00000011# * t# * t# * t#
 m# = m# + 26.9281592# * k& - .0000544 * t# * t# - .0000001 * t# * t# * t#
 m1# = m1# + 356.9562795# * k& + .0103126 * t# * t# + .00001251# * t# * t# * t#
 f# = f# + 1.4467806# * k& - .0020708 * t# * t# - .00000215# * t# * t# * t#
 e# = 1 - .002516 * t# - .0000074 * t# * t#

 JDE# = JDE# + 27.321582241# * k& + .000100695# * t# * t# - .000000141# * t# * t# * t# +_
 + Mond(mt% + 1) * CS(f#) + Mond(mt% + 2) * SN(m1#) + Mond(mt% + 3) * SN(2 * f#) + Mond(mt% + 4) * SN(2 * d# - m1#) + Mond(mt% + 5) * CS(m1# - f#) +_
 + Mond(mt% + 6) * CS(m1# + f#) + Mond(mt% + 7) * SN(2 * d#) + Mond(mt% + 8) * SN(m#) * e# + Mond(mt% + 9) * CS(3 * f#) + Mond(mt% + 10) * SN(m1# + 2 * f#) +_
 + Mond(mt% + 11) * CS(2 * d# - f#) + Mond(mt% + 12) * CS(2 * d# - m1# - f#) + Mond(mt% + 13) * CS(2 * d# - m1# + f#) + Mond(mt% + 14) * CS(2 * d# + f#) +_
 + Mond(mt% + 15) * SN(2 * m1#) + Mond(mt% + 16) * SN(m1# - 2 * f#) + Mond(mt% + 17) * CS(2 * m1# - f#) + Mond(mt% + 18) * SN(m1# + 3 * f#) +_
 + Mond(mt% + 19) * SN(2 * d# - m# - m1#) * e# + Mond(mt% + 20) * CS(m1# - 2 * f#) + Mond(mt% + 21) * SN(2 * d# - 2 * m1#) +_
 + Mond(mt% + 22) * SN(f#) + Mond(mt% + 23) * SN(2 * d# + m1#) + Mond(mt% + 24) * CS(m1# + 2 * f#) + Mond(mt% + 25) * SN(2 * d# - m#) * e# + Mond(mt% + 26) * SN(m1# + f#) +_
 + Mond(mt% + 27) * SN(m# - m1#) * e# + Mond(mt% + 28) * SN(m1# - 3 * f#) + Mond(mt% + 29) * SN(2 * m1# + f#) + Mond(mt% + 30) * CS(2 * d# - 2 * m1# - f#) +_
 + Mond(mt% + 31) * SN(3 * f#) + Mond(mt% + 32) * CS(m1# + 3 * f#) + Mond(mt% + 33) * CS(2 * m1#) + Mond(mt% + 34) * CS(2 * d# - m1#)
 JDE# = JDE# + Mond(mt% + 35) * CS(2 * d# + m1# + f#) + Mond(mt% + 36) * CS(m1#) + Mond(mt% + 37) * SN(3 * m1# + f#) + Mond(mt% + 38) * SN(2 * d# - m1# + f#) +_
 + Mond(mt% + 39) * CS(2 * d# - 2 * m1#) + Mond(mt% + 40) * CS(d# + f#) + Mond(mt% + 41) * SN(m# + m1#) * e# + Mond(mt% + 42) * SN(2 * d# - 2 * f#) +_
 + Mond(mt% + 43) * CS(2 * m1# + f#) + Mond(mt% + 44) * CS(3 * m1# + f#)

 mt% = mt% + 44
 Dek# = 23.6961 - .013004 * t# + Mond(mt% + 1) * SN(f#) + Mond(mt% + 2) * CS(2 * f#) + Mond(mt% + 3) * SN(2 * d# - f#) + Mond(mt% + 4) * SN(3 * f#) +_
 + Mond(mt% + 5) * CS(2 * d# - 2 * f#) + Mond(mt% + 6) * CS(2 * d#) + Mond(mt% + 7) * SN(m1# - f#) + Mond(mt% + 8) * SN(m1# + 2 * f#) + Mond(mt% + 9) * CS(f#) +_
 + Mond(mt% + 10) * SN(2 * d# + m# - f#) * e# + Mond(mt% + 11) * SN(m1# + 3 * f#) + Mond(mt% + 12) * SN(d# + f#) +_
 + Mond(mt% + 13) * SN(m1# - 2 * f#) + Mond(mt% + 14) * SN(2 * d# - m# - f#) * e# + Mond(mt% + 15) * SN(2 * d# - m1# - f#) + Mond(mt% + 16) * CS(m1# + f#) +_
 + Mond(mt% + 17) * CS(m1# + 2 * f#) + Mond(mt% + 18) * CS(2 * m1# + f#) + Mond(mt% + 19) * CS(m1# - 3 * f#) + Mond(mt% + 20) * CS(2 * m1# - f#)
 Dek# = Dek# + Mond(mt% + 21) * CS(m1# - 2 * f#) + Mond(mt% + 22) * SN(2 * m1#) + Mond(mt% + 23) * SN(3 * m1# + f#) + Mond(mt% + 24) * CS(2 * d# + m# - f#) * e# +_
 + Mond(mt% + 25) * CS(m1# - f#) + Mond(mt% + 26) * CS(3 * f#) + Mond(mt% + 27) * SN(2 * d# + f#) + Mond(mt% + 28) * CS(m1# + 3 * f#) +_
 + Mond(mt% + 29) * CS(d# + f#) + Mond(mt% + 30) * SN(2 * m1# - f#) + Mond(mt% + 31) * CS(3 * m1# + f#) + Mond(mt% + 32) * CS(2 * d# + 2 * m1# + f#) +_
 + Mond(mt% + 33) * SN(2 * d# - 2 * m1# - f#) + Mond(mt% + 34) * CS(2 * m1#) + Mond(mt% + 35) * CS(m1#) + Mond(mt% + 36) * SN(2 * f#) + Mond(mt% + 37) * SN(m1# + f#)
END SUB

SUB Mondknoten (JD&, JD_mk&, Sekunde%, Minute%, Stunde%, AName%)
  'Bezug: Neumond der 21.1.2000
  CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
  CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", JDS&, 0)
  IF Jahr& < 0 THEN Jahr& = Jahr& + 1 'das Jahr Null hinzurechnen
  k# = INT((Jahr& + (JD& + st% - JDS&) / 365 - 2000.05) * 13.4223)
  WHILE JD_mk& < JD&
    t# = k# / 1342.23
    d# = 183.638 + 331.73735691 * k# + 0.0015057 * t# ^ 2 + 0.00000209 * t# ^ 3 - 0.00000001 * t# ^ 4
    e# = 1 - 0.002516 * t# - 0.0000074 * t# ^ 2
    m# = 17.4006 + 26.82037250 * k# + 0.0000999 * t# ^ 2 + 0.00000006 * t# ^ 3
    m1# = 38.3776 + 355.52747322 * k# + 0.0123577 * t# ^ 2 + 0.000014628 * t# ^ 3 - 0.000000069 * t# ^ 4
    o# = 123.9767 - 1.44098949 * k# + 0.0020625 * t# ^ 2 + 0.00000214 * t# ^ 3 - 0.000000016 * t# ^ 4
    v# = 299.75 + 132.85 * t# - 0.009173 * t# ^ 2
    p# = o# + 272.75 - 2.3 * t#
    JDE# = 2451565.1619 + 27.212220817 * k# + 0.0002572 * t# ^ 2 + 0.000000021 * t# ^ 3 - 0.000000000088 * t# ^ 4 - .4721 * SN(m1#) - 0.1649 * SN(2 * d#) +_
    - .0868 * SN(2 * d# - m1#) + 0.0084 * SN(2 * d# + m1#) - 0.0083 * SN(2 * d# - m#) * e# - 0.0039 * SN(2 * d# - m# - m1#) * e# +_
    + 0.0034 * SN(2 * m1#) - 0.0031 * SN(2 * d# - 2 * m1#) + 0.003 * SN(2 * d# + m#) * e# + 0.0028 * SN(m# - m1#) * e# + 0.0026 * SN(m#) +_
    + 0.0025 * SN(4 * d#) + 0.0024 * SN(d#) + 0.0022 * SN(m# + m1#) * e# + 0.0017 * SN(o#) + 0.0014 * SN(4 * d# - m1#) +_
    + 0.0005 * SN(2 * d# + m# - m1#) * e# + 0.0004 * SN(2 * d# - m# + m1#) * e# - 0.0003 * SN(2 * d# - 2 * m#) * e# +_
    + 0.0003 * SN(4 * d# - m#) * e# + 0.0003 * SN(v#) + 0.0003 * SN(p#)
    CALL JulTageZeit (JDE#, Sekunde%, Minute%, Stunde%, JD_mk&)
    k# = k# + .5
  WEND
  IF k# - INT(k#) = .5 THEN AName% = 14 ELSE AName% = 15 'auf- oder absteigend
END SUB

SUB Mondphase (JD&, AName%, Sekunde%, Minute%, Stunde%)
  'Bezug: Neumond der 6.1.2000
  CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
  CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", JDS&, 0)
  IF Jahr& < 0 THEN Jahr& = Jahr& + 1 'das Jahr Null hinzurechnen
  'Neumond + Sonnenfinsternis
  AName% = 0
  t% = -20
  WHILE JD_nm& < JD&
    k_nm# = INT((Jahr& + (JD& + t% - JDS&) / 365 - 2000) * 12.3685)
    CALL Mondphase_Neumondkorrekturen(k_nm#, JDE_nm#)
    CALL Mondphase_Zusatzkorrekturen(k_nm#, JDE_nm#)
    CALL JulTageZeit (JDE_nm#, s%, m%, h%, JD_nm&)
    IF JD_nm& = JD& THEN
     AName% = 1: Sekunde% = s%: Minute% = m%: Stunde% = h%
     IF (SchiKa&& AND 2 ^ 61) = 2 ^ 61 THEN
       CALL Finsternis (k_nm#, JDE_nm#, AName%)
       IF AName% <> 1 THEN CALL JulTageZeit(JDE_nm#, Sekunde%, Minute%, Stunde%, JD_fi&) '<> "Neumond"
       IF JD_fi& <> JD_nm& THEN Sekunde% = s%: Minute% = m%: Stunde% = h% 'Notnagel wenn Finsternis und Neumond ber Mitternacht auseinanderliegen
      END IF
      EXIT SUB
    END IF
    t% = t% + 1
  WEND
  'Erstes Viertel
  t% = -20
  WHILE JD_ev& < JD&
    k_ev# = INT((Jahr& + (JD& + t% - JDS&) / 365 - 2000) * 12.3685) + .25
    CALL Mondphase_Viertelmondkorrekturen(k_ev#, JDE_ev#)
    CALL Mondphase_Zusatzkorrekturen(k_ev#, JDE_ev#)
    CALL JulTageZeit (JDE_ev#, s%, m%, h%, JD_ev&)
    IF JD_ev& = JD& THEN AName% = 2: Sekunde% = s%: Minute% = m%: Stunde% = h%: EXIT SUB
    t% = t% + 1
  WEND
  'Vollmond + Mondfinsternis
  t% = -20
  WHILE JD_vm& < JD&
    k_vm# = INT((Jahr& + (JD& + t% - JDS&) / 365 - 2000) * 12.3685) + .5
    CALL Mondphase_Vollmondkorrekturen(k_vm#, JDE_vm#)
    CALL Mondphase_Zusatzkorrekturen(k_vm#, JDE_vm#)
    CALL JulTageZeit (JDE_vm#, s%, m%, h%, JD_vm&)
    IF JD_vm& = JD& THEN
      AName% = 3: Sekunde% = s%: Minute% = m%: Stunde% = h%
      IF (SchiKa&& AND 2 ^ 61) = 2 ^ 61 THEN
        CALL Finsternis (k_vm#, JDE_vm#, AName%)
        IF AName% = 3 THEN CALL JulTageZeit (JDE_vm#, Sekunde%, Minute%, Stunde%, JD_fi&) '<> Vollmond
        IF JD_fi& <> JD_vm& THEN Sekunde% = s%: Minute% = m%: Stunde% = h% 'Notnagel wenn Finsternis und Vollmond ber Mitternacht auseinanderliegen
      END IF
      EXIT SUB
    END IF
    t% = t% + 1
  WEND
  'Letztes Viertel
  t% = -20
  WHILE JD_lv& < JD&
    k_lv# = INT((Jahr& + (JD& + t% - JDS&) / 365 - 2000) * 12.3685) + .75
    CALL Mondphase_Viertelmondkorrekturen(k_lv#, JDE_lv#)
    CALL Mondphase_Zusatzkorrekturen(k_lv#, JDE_lv#)
    CALL JulTageZeit (JDE_lv#, s%, m%, h%, JD_lv&)
    IF JD_lv& = JD& THEN AName% = 4: Sekunde% = s%: Minute% = m%: Stunde% = h%: EXIT SUB
    t% = t% + 1
  WEND
END SUB

SUB Mondphase_Variablen(k#, t#, JDE#, e#, m#, m1#, f#, o#)
  t# = k# / 1236.85
  JDE# = 2451550.09765# + 29.530588853# * k# + .0001337 * t# * t# - .00000015# * t# * t# * t# + .00000000073# * t# * t# * t# * t#
  e# = 1 - .002516 * t# - .0000074 * t# * t#
  m# = 2.5534# + 29.10535669# * k# - .0000218 * t# * t# - .00000011# * t# * t# * t#
  m1# = 201.5643# + 385.81693528# * k# + .1017438# * t# * t# + .00001239# * t# * t# * t# - .000000058# * t# * t# * t# * t#
  f# = 160.7108# + 390.67050274# * k# - .0016341 * t# * t# - .00000227# * t# * t# * t# + .000000011# * t# * t# * t# * t#
  o# = 124.7746# - 1.5637558# * k# + .0020691 * t# * t# + .00000215# * t# * t# * t#
END SUB

SUB Mondphase_Neumondkorrekturen(k#, JDE#)
  CALL Mondphase_Variablen(k#, t#, JDE#, e#, m#, m1#, f#, o#)
  JDE# = JDE# -.4072 * SN(m1#) + .17241 * e# * SN(m#) + .01608 * SN(2 * m1#) + .01039 * SN(2 * f#) + .00739 * e# * SN(m1# - m#) - .00514 * e# * SN(m1# + m#) + .00208 * e# * e# * SN(2 * m#) - .00111 * SN(m1# - 2 * f#) - .00057 * SN(m1# + 2 * f#) +_
  + .00056 * e# * SN(2 * m1# + m#) - .00042 * SN(3 * m1#) + .00042 * e# * SN(m# + 2 * f#) + .00038 * e# * SN(m# - 2 * f#) - .00024 * e# * SN(2 * m1# - m#) - .00017 * SN(o#) - .00007 * SN(m1# + 2 * m#) + .00004 * SN(2 * m1# - 2 * f#) +_
  + .00004 * SN(3 * m#) + .00003 * SN(m1# + m# - 2 * f#) + .00003 * SN(2 * m1# + 2 * f#) - .00003 * SN(m1# + m# + 2 * f#) + .00003 * SN(m1# - m# + 2 * f#) - .00002 * SN(m1# - m# - 2 * f#) - .00002 * SN(3 * m1# + m#) + .00002 * SN(4 * m1#)
END SUB

SUB Mondphase_Vollmondkorrekturen(k#, JDE#)
  CALL Mondphase_Variablen(k#, t#, JDE#, e#, m#, m1#, f#, o#)
  JDE# = JDE# -.40614 * SN(m1#) + .17302 * e# * SN(m#) + .01614 * SN(2 * m1#) + .01043 * SN(2 * f#) + .00734 * e# * SN(m1# - m#) - .00515 * e# * SN(m1# + m#) + .00209 * e# * e# * SN(2 * m#) - .00111 * SN(m1# - 2 * f#) - .00057 * SN(m1# + 2 * f#) +_
  + .00056 * e# * SN(2 * m1# + m#) - .00042 * SN(3 * m1#) + .00042 * e# * SN(m# + 2 * f#) + .00038 * e# * SN(m# - 2 * f#) - .00024 * e# * SN(2 * m1# - m#) - .00017 * SN(o#) - .00007 * SN(m1# + 2 * m#) + .00004 * SN(2 * m1# - 2 * f#) +_
  + .00004 * SN(3 * m#) + .00003 * SN(m1# + m# - 2 * f#) + .00003 * SN(2 * m1# + 2 * f#) - .00003 * SN(m1# + m# + 2 * f#) + .00003 * SN(m1# - m# + 2 * f#) - .00002 * SN(m1# - m# - 2 * f#) - .00002 * SN(3 * m1# + m#) + .00002 * SN(4 * m1#)
END SUB

SUB Mondphase_Viertelmondkorrekturen(k#, JDE#)
  CALL Mondphase_Variablen(k#, t#, JDE#, e#, m#, m1#, f#, o#)
  JDE# = JDE# -.62801 * SN(m1#) + .17172 * e# * SN(m#) - .01183 * e# * SN(m1# + m#) + .00862 * SN(2 * m1#) + .00804 * SN(2 * f#) + .00454 * e# * SN(m1# - m#) + .00204 * e# * e# * SN(2 * m#) - .0018 * SN(m1# - 2 * f#) - .0007 * SN(m1# + 2 * f#) +_
  - .0004 * SN(3 * m1#) - .00034 * e# * SN(2 * m1# - m#) + .00032 * e# * SN(m# + 2 * f#) + .00032 * e# * SN(m# - 2 * f#) - .00028 * e# * e# * SN(m1# + 2 * m#) + .00027 * e# * SN(2 * m1# + m#) - .00017 * SN(o#) +_
  - .00005 * SN(m1# - m# - 2 * f#) + .00004 * SN(2 * m1# + 2 * f#) - .00004 * SN(m1# + m# + 2 * f#) + .00004 * SN(m1# - 2 * m#) + .00003 * SN(m1# + m# - 2 * f#) + .00003 * SN(3 * m#) + .00002 * SN(2 * m1# - 2 * f#) +_
  + .00002 * SN(m1# - m# + 2 * f#) - .00002 * SN(3 * m1# + m#)
  w# = .00306 - .00038 * e# * CS(m#) + .00026 * CS(m1#) - .00002 * CS(m1# - m#) + .00002 * CS(m1# + m#) + .00002 * CS(2 * f#)
  IF k# - INT(k#) = .25 THEN JDE# = JDE# + w# ELSE JDE# = JDE# - w#
END SUB

SUB Mondphase_Zusatzkorrekturen(k#, JDE#)
  JDE# = JDE# + .000325 * SN(299.77 + .107408 * k# - .009173 * t# * t#) + .000165 * SN(251.88 + .016321 * k#) + .000164 * SN(251.83 + 26.651886# * k#) + .000126 * SN(349.42 + 36.412478# * k#) + .00011 * SN(84.66 + 18.206239# * k#) +_
  + .000062 * SN(141.74 + 53.303771# * k#) + .00006 * SN(207.14 + 2.453732 * k#) + .000056 * SN(154.84 + 7.30686 * k#) + .000047 * SN(34.52 + 27.261239# * k#) + .000042 * SN(207.19 + .121824 * k#) + .00004 * SN(291.34 + 1.844379 * k#) +_
  + .000037 * SN(161.72 + 24.198154# * k#) + .000035 * SN(239.56 + 25.513099# * k#) + .000023 * SN(331.55 + 3.592518 * k#)
END SUB

SUB PeriApogaeum (JD&, JDMP#, JDMA#)
 CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
 CALL Schaltjahr(Tag%, Monat%, Jahr&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", JDS&, 0)
 IF Jahr& < 0 THEN Jahr& = Jahr& + 1

 'Apogum
 k# = INT(((Jahr& + (JD& - JDS&) / (337 + Monatstage%(2))) - 1999.97) * 13.2555)
 k# = k# + .5
 d# = 171.9179 + 335.9106046# * k# - .010025 * t# * t# - .00001156# * t# * t# * t# + .000000055# * t# * t# * t# * t#
 m# = 347.3477 + 27.1577721# * k# - .0008323 * t# * t# - .000001 * t# * t# * t#
 f# = 316.6109 + 364.5287911# * k# - .0125131 * t# * t# - .0000148 * t# * t# * t#
 JDMA# = 2451534.6698# + 27.55454988# * k# - .0006886 * t# * t# - .000001098# * t# * t# * t# + .0000000052# * t# * t# +_
 + .4392 * SN(2 * d#) + .0684 * SN(4 * d#) + (.0456 - .00011 * t#) * SN(m#) + (.0426 - .00011 * t#) * SN(2 * d# - m#) + .0212 * SN(2 * f#) - .0189 * SN(d#) + .0144 * SN(6 * d#) + .0113 * SN(4 * d# - m#) + .0047 * SN(2 * d# + 2 * f#) +_
 + .0036 * SN(d# + m#) + .0035 * SN(8 * d#) + .0034 * SN(6 * d# - m#) - .0034 * SN(2 * d# - 2 * f#) + .0022 * SN(2 * d# - 2 * m#) - .0017 * SN(3 * d#) + .0013 * SN(4 * d# + 2 * f#) + .0011 * SN(8 * d# - m#) + .001 * SN(4 * d# - 2 * m#) +_
 + .0009 * SN(10 * d#) + .0007 * SN(3 * d# + m#) + .0006 * SN(2 * m#) + .0005 * SN(2 * d# + m#) + .0005 * SN(2 * d# + 2 * m#) + .0004 * SN(6 * d# + 2 * f#) + .0004 * SN(6 * d# - 2 * m#) + .0004 * SN(10 * d# - m#) - .0004 * SN(5 * d#) +_
 - .0004 * SN(4 * d# - 2 * f#) + .0003 * SN(2 * f# + m#) + .0003 * SN(12 * d#) + .0003 * SN(2 * d# + 2 * f# - m#) - .0003 * SN(d# - m#)

 'Perigum
 IF Jahr& > 1999 THEN JDS& = JDS& - 6 ELSE JDS& = JDS& + 10
 k# = FIX(((Jahr& + (JD& - JDS&) / (337 + Monatstage%(2))) - 1999.97) * 13.2555)
 t# = k# / 1325.55
 d# = 171.9179 + 335.9106046# * k# - .010025 * t# * t# - .00001156# * t# * t# * t# + .000000055# * t# * t# * t# * t#
 m# = 347.3477 + 27.1577721# * k# - .0008323 * t# * t# - .000001 * t# * t# * t#
 f# = 316.6109 + 364.5287911# * k# - .0125131 * t# * t# - .0000148 * t# * t# * t#
 JDMP# = 2451534.6698# + 27.55454988# * k# - .0006886 * t# * t# - .000001098# * t# * t# * t# + .0000000052# * t# * t# +_
 - 1.6769 * SN(2 * d#) + .4589 * SN(4 * d#) - .1856 * SN(6 * d#) + .0883 * SN(8 * d#) - (.0773 + .00019 * t#) * SN(2 * d# - m#) + (.0502 - .00013 * t#) * SN(m#) - .046 * SN(10 * d#) + (.0422 - .00011 * t#) * SN(4 * d# - m#) +_
 - .0256 * SN(6 * d# - m#) + .0253 * SN(12 * d#) + .0237 * SN(d#) + .0162 * SN(8 * d# - m#) - .0145 * SN(14 * d#) + .0129 * SN(2 * f#) - .0112 * SN(3 * d#) - .0104 * SN(10 * d# - m#) + .0086 * SN(16 * d#) + .0069 * SN(12 * d# - m#) +_
 + .0066 * SN(5 * d#) - .0053 * SN(2 * d# + 2 * f#) - .0052 * SN(18 * d#) - .0046 * SN(14 * d# - m#) - .0041 * SN(7 * d#) + .004 * SN(2 * d# + m#) + .0032 * SN(20 * d#) - .0032 * SN(d# + m#) + .0031 * SN(16 * d# - m#)
 JDMP# = JDMP# - .0029 * SN(4 * d# + m#) - .0027 * SN(2 * d# - 2 * m#) + .0024 * SN(4 * d# - 2 * m#) - .0021 * SN(6 * d# - 2 * m#) - .0021 * SN(22 * d#) - .0021 * SN(18 * d# - m#) + .0019 * SN(6 * d# + m#) - .0018 * SN(11 * d#) - .0014 * SN(8 * d# + m#) +_
 - .0014 * SN(4 * d# - 2 * f#) - .0014 * SN(6 * d# - 2 * f#) + .0014 * SN(3 * d# + m#) - .0014 * SN(5 * d# + m#) + .0013 * SN(13 * d#) + .0013 * SN(20 * d# - m#) + .0011 * SN(3 * d# + 2 * m#) - .0011 * SN(4 * d# + 2 * f# - 2 * m#) +_
 - .001 * SN(d# + 2 * m#) - .0009 * SN(22 * d# - m#) - .0008 * SN(4 * f#) + .0008 * SN(6 * d# - 2 * f#) + .0008 * SN(2 * d# - 2 * f# + m#) + .0007 * SN(2 * m#) + .0007 * SN(2 * f# - m#) + .0007 * SN(2 * d# + 4 * f#) +_
 - .0006 * SN(2 * f# - 2 * m#) - .0006 * SN(2 * d# - 2 * f# + 2 * m#) + .0006 * SN(24 * d#) + .0005 * SN(4 * d# - 4 * f#) + .0005 * SN(2 * d# + 2 * m#) - .0004 * SN(d# - m#) + .0027 * SN(9 * d#) + .0027 * SN(4 * d# + 2 * f#)
END SUB

SUB PerihelAphel (JD&, JDEP#, JDEA#)
  'k# = Integer fr das Perihel und Integer +.5 fr das Aphel
   CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)

  'Perihel (Sonnennhe)
  k# = INT(.99997 * ((Jahr& + .5) - 2000.01))
  JDEP# = 2451547.507# + 365.2596358# * k# + .0000000158# * k# * k#
  JDEP# = JDEP# + 1.278 * SN(328.41 + 132.788585# * k#) - .055 * SN(316.13 + 584.903153# * k#) - .091 * SN(346.2 + 450.380738# * k#) - .056 * SN(136.95 + 659.306737# * k#) - .045 * SN(249.52 + 329.653368# * k#)

  CALL JulTageZeit(JDEP#, Sekunde%, Minute%, Stunde%, JDT&)
  IF ABS(JDT& - JD&) < 2 THEN 'Rechenzeit einschrnken
    CALL Sonnenbahn(JDEP#, Laenge#, Hoehe#, Test#)
    'Meeus gibt einen mittleren Fehler von 3h an, .1667 = ~4h
    FOR t# = JDEP# - .1667 TO JDEP# + .1667 STEP .0104 'Schrittweite = 15 Minuten
      CALL Sonnenbahn(t#, Laenge#, Hoehe#, Entf#)
      IF Entf# < Test# THEN Test# = Entf#: JDEP# = t#
    NEXT t#
    JDEA# = 0: EXIT SUB
  END IF

  'Aphel (Sonnenferne)
  k# = k# + .5
  JDEA# = 2451547.507# + 365.2596358# * k# + .0000000158# * k# * k#
  JDEA# = JDEA# - 1.352 * SN(328.41 + 132.788585# * k#) + .061 * SN(316.13 + 584.903153# * k#) + .062 * SN(346.2 + 450.380738# * k#) + .029 * SN(136.95 + 659.306737# * k#) + .031 * SN(249.52 + 329.653368# * k#)

  CALL JulTageZeit(JDEA#, Sekunde%, Minute1%, Stunde1%, JDT&)
  IF ABS(JDT& - JD&) < 2 THEN
    FOR t# = JDEA# - .1667 TO JDEA# + .1667 STEP .0104
      CALL Sonnenbahn(t#, Laenge#, Hoehe#, Entf#)
      IF Entf# > Test# THEN Test# = Entf#: JDEA# = t#
    NEXT t#
    JDEP# = 0
   END IF
END SUB

SUB QUAD (yminus#, yo#, yplus#, xe#, ye#, zero1#, zero2#, nz%)
 nz% = 0
 a# = .5 * (yminus# + yplus#) - yo#
 b# = .5 * (yplus# - yminus#)
 c# = yo#
 xe# = -b# / (2 * a#)
 ye# = (a# * xe# + b#) * xe# + c#
 dis# = b# * b# - 4 * a# * c#
 IF dis# >= 0 THEN
   dx# = .5 * SQR(dis#) / ABS(a#)
   zero1# = xe# - dx#
   zero2# = xe# + dx#
   IF ABS(zero1#) <= 1 THEN nz% = nz% + 1
   IF ABS(zero2#) <= 1 THEN nz% = nz% + 1
   IF zero1# < -1 THEN zero1# = zero2#
 END IF
END SUB

SUB Sonnenbahn(JDE#, Laenge#, Breite#, Entfernung#)
 'Lnge
 t# = (JDE# - 2451545) / 36525
 lo# = 280.46645 + 36000.76983 * t# + .0003032 * t# ^ 2
 m# = 357.5291 + 35999.0503 * t# - .0001559 * t# ^ 2 - .00000048 * t# ^ 3
 e# = .016708617 - .000042037 * t# - .0000001236 * t# ^ 2
 c# = (1.9146000 - .004817 * t# - .000014 * t# ^ 2) * SN(m#) + (.019993 - .000101 * t#) * SN(2 * m#) + .00029 * SN(3 * m#)
 op# = lo# + c#
 v# = m# + c#
 o# = 125.04 - 1934.136 * t#
 l# = op# - .00569 - .00478 * SN(o#)
 Laenge# = Kreis(l#)

 'Breite
 l1# = op# - 1.397 * t# - 0.00031 * t# ^ 2
 db# = 0.03916 * (CS(l1#) - SN(l1#))
 t# = (JDE# - 2451545) / 365250
 FOR t1% = 1 TO 5: b0# = b0# + Erde(1, t1%) * COS(Erde(2, t1%) + Erde(3, t1%) * t#): NEXT t1%
 FOR t1% = 5 TO 7: b1# = b1# + Erde(1, t1%) * COS(Erde(2, t1%) + Erde(3, t1%) * t#): NEXT t1%
 Breite# = -(b0# + b1# * t#) / 10 ^ 8  / .0174532925199433#
 CALL KreisGradMin (Breite#, 0, Sekunden#)
 Breite# = Sekunden# + db#

 'Radiusvektor
 FOR t1% = 8 TO 47: r0# = r0# + Erde(1, t1%) * COS(Erde(2, t1%) + Erde(3, t1%) * t#): NEXT t1%
 FOR t1% = 48 TO 57: r1# = r1# + Erde(1, t1%) * COS(Erde(2, t1%) + Erde(3, t1%) * t#): NEXT t1%
 FOR t1% = 58 TO 63: r2# = r2# + Erde(1, t1%) * COS(Erde(2, t1%) + Erde(3, t1%) * t#): NEXT t1%
 FOR t1% = 64 TO 65: r3# = r3# + Erde(1, t1%) * COS(Erde(2, t1%) + Erde(3, t1%) * t#): NEXT t1%
 r4# = Erde(1, 66) * COS(Erde(2, 66) + Erde(3, 66) * t#)
 rv# = r0# + r1# * t# + r2# * t# ^ 2 + r3# * t# ^ 3 + r4# * t# ^ 4
 Entfernung# = rv# / 10 ^ 8
END SUB

SUB Sternzeit (Stzeit$)
 CALL AufUnterDaten(0, lambda#, phi#, Zone#)
 CALL DatumWandel("", Tag%, Monat%, Jahr&, 0)
 CALL Sommerzeit(Tag%, Monat%, Jahr&, Anfang%, Ende%)
 IF Monat% * 100 + Tag% > Anfang% AND Monat% * 100 + Tag% <= Ende% THEN Zone# = Zone# + 1 'Sommerzeit
 CALL DatumWandel(Datum$, Tag%, Monat%, Jahr&, Modus%)
 CALL DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, "Datum", JD&, 0)
 CALL TagesSekunden(TagSek&)
 TagSek& = TagSek& - 43200 - Zone# * 3600
 JDE# = JD& + TagSek& / 86400
 t# = (JDE# - 2451545) / 36525
 st# = 280.46061837# + 360.98564736629# * (JDE# - 2451545) + .000387933# * t# * t# - t# * t# * t# / 38710000 - lambda#
 st# = st# MOD 360: IF st# < 0 THEN st# = st# + 360
 st# = INT(st# / 15 * 3600) 'Sekunden
 Std% = INT(st# / 3600): st# = st# - Std% * 3600
 Minu% = INT(st# / 60): st# = st# - Minu% * 60
 Stzeit$ = USING$("##", Std%) + ":" + RIGHT$("00" + LTRIM$(STR$(Minu%)), 2) + ":" + RIGHT$("00" + LTRIM$(STR$(st#)), 2)
END SUB

SUB Nutation_Ekliptikneigung(JDE#, df#, de#, ekn#)
  'df# = Nutation in Lnge
  'de# = Nutation in der Schiefe der Ekliptik
  'ekn# = Neigung der Ekliptik
  t# = (JDE# - 2451545) / 36525
  l# = 280.4665 + 36000.7698# * t#
  l1# = 218.3165 + 481267.8813# * t#
  o# = 125.04452# - 1934.136261# * t#
  df# = (-17.2 * SN(o#) - 1.32 * SN(2 * l#) - .23 * SN(2 * l1#) + .21 * SN(2 * o#)) / 3600
  de# = (9.2 * CS(o#) + .57 * CS(2 * l) + .1 * CS(2 * l1#) - .09 * CS(2 * o#)) / 3600
  eo# = 23 + 26 / 60 + (21.448 - 46.815 * t# - .00059 * t# ^ 2 + .001813 * t# ^ 3) / 3600
  ekn# = eo# + de#
END SUB

SUB Praezession(Jahr&, Laenge#, DeltaL#)
  'Abweichung vom 1.1.2000 an
  DeltaL# = (Jahr& - 1980) * 360 / 25800
END SUB

SUB MondbahnUhrzeit(Tag%, Monat%, Jahr&, JD&, JDV#, Nummer%)
   CALL AufUnterDaten (0, lambda#, phi#, Zone#)
   JDA# = JD& - .5 - Zone# * 3600 / 86400
   JDE# = JD& + .5 - Zone# * 3600 / 86400
   CALL Mondbahn (JDA#, LaengeA#, 0, 0, 0)
   CALL Mondbahn (JDE#, LaengeE#, 0, 0, 0)
   IF LaengeE# < LaengeA# THEN LaengeA# = LaengeA# - 360 '0 werden berschritten


   FOR t% = 1 TO 12
     IF (SchiKa2& AND 2 ^ 14) = 2 ^ 14 THEN Ziel# = TKMASLOG(t%) ELSE Ziel# = TKMASNOM(t%)
     IF (SchiKa2& AND 2 ^ 15) = 2 ^ 15 THEN CALL Praezession(Jahr&, Ziel#, DeltaL#): Ziel# = Kreis(Ziel# + DeltaL#)
     IF LaengeA# <= 0 AND Ziel# > 180 THEN Ziel# = Ziel# - 360
     IF Ziel# >= LaengeA# AND Ziel# < LaengeE# THEN Test% = 1: EXIT FOR
   NEXT t%
   Nummer% = t%

   'Uhrzeit suchen
   IF Test% THEN
     DO
       JDV# = (JDA# + JDE#) / 2
       CALL Mondbahn (JDV#, Laenge#, 0, 0, 0)
       IF LaengeA# <= 0 AND Laenge# > 180 THEN Laenge# = Laenge# - 360
       IF Laenge# > Ziel# THEN JDE# = JDV#
       IF Laenge# < Ziel# THEN JDA# = JDV#
     LOOP WHILE ABS(JDE# - JDA#) > .00034722
   ELSE
     JDV# = 0
   END IF
END SUB

