'Konstanten
%schwarz = 0: %blau = 1: %gruen = 2: %tuerkis = 3: %rot = 4: %purpur = 5: %braun = 6: %hgrau = 7
%grau = 8 + 0: %hblau = 8 + 1: %hgruen = 8 + 2: %htuerkis = 8 + 3: %hrot = 8 + 4: %hpurpur = 8 + 5: %gelb = 8 + 6: %weiss = 8 + 7

%kommlaenge = 239   'max. Textlnge bei der Eingabe, mehr wie 239 geht ohnehin nicht
%HSpalte = 40       'Maximale Bildschirmbreite / 2
%AZeile = 2         'Erste Bildschirmzeile
%HGrund = 0
%JuTagEnde = 64800  'jdisches Tagesende um 18.00 in Sekunden
%NamTagLaenge = 23  'Lnge eines Namenstag und Feiertageintrages
%MarkLaenge = 1     'Lnge des Kalendermarkierungstextes ("1" oder "0")

diatitleattr% = 16 * %hgrau + %rot    'Titelfarbe
diaframeattr% = 16 * %HGrund + %hgrau 'Rahmenfarbe
diaframetype% = 2                     'Rahmentyp
diaswittxt% = 16 * %hgrau + %schwarz  'Hintergund und berschriftenfarbe
diaswitkey% = 16 * %schwarz           'Farbe der Alttaste der berschrift
diaswitsel% = 16 * %hgrau + %blau     'Hintergrund und Farbe der gewhlten berschrift
diaradtxt% = 16 * %blau + %gelb       'Auswahltext
diaradkey% = %schwarz                 'Farbe der Alttaste des Auswahltextes
diaradsel% = 16 * %blau + %weiss      'Farbe des gewhlten Auswahltextes
diaviewattr% = 16 * %blau + %gelb     'Eingabe nicht gewhlt
diainputattr% = 16 * %blau + %weiss   'Eingabe gewhlt
diainputkey% = %schwarz               'Eingabe Farbe der Alttaste
diapushtxt% = 16 * %blau + %gelb      'Eingabe Auswahltext
diapushkey% = %schwarz                'Eingabe Farbe der Alttaste des Auswahltextes
diapushsel% = 16 * %blau + %weiss     'Eingabe Farbe des gewhlten Auswahltextes
diaprintattr% = %schwarz              'Farbe fr diaprint

'Allgemeine Variablen
SHARED SchiKa&&, SchiKa2&, EZeile%, Differenz&, SchiKal$, AutoEnde&, AutoPause&, BName$
SHARED KLaenge, KBreite, KZone, KName$, KZugriff%, KoordAnzeige%, Zeit$, Zeitkorrektur&
SHARED JDJulGreg&, DatJulGreg&          'Datum der Kalenderreform
SHARED FeiertagFarbeTest%               'Test fr die Umstellung der Feiertage auf rot/weiss
SHARED Festjahr%                        'Fr die Wahl des Kirchenjahres
SHARED Feriendateiname$, Ferien%        'Die Feriendaten der einzelnen Bundeslnder
SHARED Monatsnamedatei$, MonatsNameNr%  'Die Datei der Monatsnamen links
SHARED Monatsdatei$                     'Die Datei der Hauptmonatsnamen rechts
SHARED JulMonatsnamedatei$, JulMonatsnameNr% 'Der Monatsname des Julianischen Kalenders
SHARED KopMonatsnamedatei$, KopMonatsnameNr% 'Der Monatsname des Koptischen Kalenders
SHARED Infodatei$, InfoNr%              'Aktuelle Kalenderinfo
SHARED Daemmerung%                      'Dmmerungsart (brgerlich oder nautisch
SHARED AeraMaya&, AeraTzolkin&, AeraHaab&, AeraAztek260&, AeraAztek365&, MayaAnzeige% 'Maya Epochen und Anzeigemodus
SHARED OsterKalDat%                             'Osterkalender
SHARED Histkal$, Herrkal$, Sankto%              'Histkal Dateiname
SHARED JulJahrAnfang%, AeraJulian&              'Julianischer Jahresanfang und Epoche
SHARED AeraAegytisch&                           'gyptische Epoche
SHARED AeraKoptisch&                            'Koptische Epoche
SHARED AeraGriechisch&                          'Griechische Epoche
SHARED AeraBabylonisch&, BabylMod%              'Babylonische Epoche
DIM STATIC einaus(48) AS SHARED STRING          'Pull-Down-Men
DIM DYNAMIC Text1(1), Text2(1) AS SHARED STRING 'Seitenausgabe
SHARED AbsLaenge%, PerTagLaenge%, PerWocheLaenge%, PerMonatLaenge%, PerJahrLaenge%, WTLaenge% 'Terminverwaltung
'Hauptkalender
DIM STATIC Monatstage(12) AS SHARED INTEGER
RESTORE MonTage: FOR t% = 1 TO 12: READ Monatstage%(t%): NEXT
'Chinesischer
DIM STATIC NMond(13, 1) AS SHARED LONG
SHARED ChinMod%
'Franzsischer
SHARED FranzMod%
'Bad
SHARED BadiMod%
'Mond-Tierkreis
SHARED TierkreisMod%
'Jdischer
DIM STATIC Judtage(13) AS SHARED INTEGER
'DIM STATIC Judtage1(13) AS SHARED INTEGER
RESTORE JudMonTage: FOR t% = 1 TO 13: READ Judtage%(t%): NEXT
'RESTORE JudMonTage: FOR t% = 1 TO 13: READ Judtage1%(t%): NEXT
'Islamischer
SHARED MohamDat%, OttomanDat%
DIM STATIC Mohamtage(12) AS SHARED INTEGER
RESTORE MohMonTage: FOR t% = 1 TO 12: READ Mohamtage%(t%): NEXT
'Die Zeichen der symbolischen Monddarstellung
DIM STATIC MondSymbolZeichen(26) AS SHARED STRING

$IF %MitSchicht
 SHARED MarkTest%
 DIM STATIC SchichtFuenf%(34), SchichtVier%(27), SchichtAlb%(27)
 SHARED SchichtFuenf%(), SchichtVier%(), SchichtAlb%()
 DIM STATIC HTFarbe$(5)
 SHARED HTFarbe$()
 RESTORE Schicht5: FOR t% = 0 TO 34: READ SchichtFuenf%(t%): NEXT
 RESTORE Schicht4: FOR t% = 0 TO 27: READ SchichtVier%(t%): NEXT
 RESTORE SchichtAlbbruck: FOR t% = 0 TO 27: READ SchichtAlb%(t%): NEXT
$ENDIF

MonTage:
DATA 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31

MohMonTage:
DATA 30, 29, 30, 29, 30, 29, 30, 29, 30, 29, 30, 29

JudMonTage:
DATA 30, 29, 30, 29, 30, 29, 00, 30, 29, 30, 29, 30, 29

$IF %MitSchicht
Schicht5: '1=Verfgung, 2=Frh, 3=Spt, 4=Nacht, 5=Frei
DATA 2, 2, 3, 3, 4, 4, 4, 5, 5, 2, 2, 3, 3, 5, 3, 3, 5, 5, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 4, 4, 4, 4, 5, 5, 5
'DATA 2, 2, 3, 3, 4, 4, 4, 5, 5, 2, 2, 3, 3, 3, 1, 1, 5, 5, 2, 2, 2, 3, 3, 1, 1, 1, 1, 1, 4, 4, 4, 4, 5, 5, 5 'Sonntag 8 Std.

Schicht4: '2=Frh, 3=Spt, 4=Nacht, 5=Frei
DATA 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 3, 3, 5, 5, 2, 2, 2, 2, 2, 2, 2, 3, 3, 5, 5, 5, 3, 3

SchichtAlbbruck:  '2=Frh, 3=Spt, 4=Nacht, 5=Frei
DATA 3, 3, 4, 4, 5, 5, 5, 2, 2, 3, 3, 4, 4, 4, 5, 5, 2, 2, 3, 3, 5, 4, 4, 5, 5, 2, 2, 2

$ENDIF

'Variablen der im Programm benutzen Dateinamen
SHARED DN_ASTRONOM$:  DN_ASTRONOM$ = "NAMEN\ASTRONOM.MON"
SHARED DN_CHJAHRZE$:  DN_CHJAHRZE$ = "NAMEN\CHJAHRZE.MON"
SHARED DN_MONDSYZE$:  DN_MONDSYZE$ = "NAMEN\MONDSYZE.MON"
SHARED DN_ROEMABL$:   DN_ROEMABL$ = "NAMEN\ROEMABL.MON"
SHARED DN_ROEMAKK$:   DN_ROEMAKK$ = "NAMEN\ROEMAKK.MON"
SHARED DN_ROEMTAG$:   DN_ROEMTAG$ = "NAMEN\ROEMTAG.MON"
SHARED DN_ROEMTAGN$:  DN_ROEMTAGN$ = "NAMEN\ROEMTAGN.MON"
SHARED DN_ROEMTAGS$:  DN_ROEMTAGS$ = "NAMEN\ROEMTAGS.MON"
SHARED DN_ROMTAG_A$:  DN_ROMTAG_A$ = "NAMEN\ROMTAG_A.MON"
SHARED DN_ROMTAG_B$:  DN_ROMTAG_B$ = "NAMEN\ROMTAG_B.MON"
SHARED DN_ROMTAG_C$:  DN_ROMTAG_C$ = "NAMEN\ROMTAG_C.MON"
SHARED DN_ROMTAG_D$:  DN_ROMTAG_D$ = "NAMEN\ROMTAG_D.MON"
SHARED DN_ROMTAG_E$:  DN_ROMTAG_E$ = "NAMEN\ROMTAG_E.MON"
SHARED DN_ROMTAG_F$:  DN_ROMTAG_F$ = "NAMEN\ROMTAG_F.MON"
SHARED DN_STANDARD$:  DN_STANDARD$ = "NAMEN\STANDARD.MON"
SHARED DN_TAGNAME$:   DN_TAGNAME$ = "NAMEN\TAGNAME.MON"
SHARED DN_WOTAGNAM$:  DN_WOTAGNAM$ = "NAMEN\WOTAGNAM.MON"

SHARED DN_ERDE$:      DN_ERDE$ = "ASTRONOM\ERDE.TER"
SHARED DN_KOEFF$:     DN_KOEFF$ = "ASTRONOM\KOEFF.TER"
SHARED DN_MOND$:      DN_MOND$ = "ASTRONOM\MOND.TER"

SHARED DN_MONDELEM$:  DN_MONDELEM$ = "ASTROLOG\MONDELEM.AST"
SHARED DN_MONDKREI$:  DN_MONDKREI$ = "ASTROLOG\MONDKREI.AST"
SHARED DN_TIERKREI$:  DN_TIERKREI$ = "ASTROLOG\TIERKREI.AST"
SHARED DN_TKMASLOG$:  DN_TKMASLOG$ = "ASTROLOG\TKMASLOG.AST"
SHARED DN_TKMASNOM$:  DN_TKMASNOM$ = "ASTROLOG\TKMASNOM.AST"
SHARED DN_TKMASTLO$:  DN_TKMASTLO$ = "ASTROLOG\TKMASTLO.AST"
SHARED DN_TKMASTRO$:  DN_TKMASTRO$ = "ASTROLOG\TKMASTRO.AST"
SHARED DN_TKMAUFAB$:  DN_TKMAUFAB$ = "ASTROLOG\TKMAUFAB.AST"
SHARED DN_TKMELEME$:  DN_TKMELEME$ = "ASTROLOG\TKMELEME.AST"
SHARED DN_TKMHEXEN$:  DN_TKMHEXEN$ = "ASTROLOG\TKMHEXEN.AST"
SHARED DN_TKMMENSC$:  DN_TKMMENSC$ = "ASTROLOG\TKMMENSC.AST"
SHARED DN_TKMNAHRU$:  DN_TKMNAHRU$ = "ASTROLOG\TKMNAHRU.AST"
SHARED DN_TKMORGAN$:  DN_TKMORGAN$ = "ASTROLOG\TKMORGAN.AST"
SHARED DN_TKMPFLAN$:  DN_TKMPFLAN$ = "ASTROLOG\TKMPFLAN.AST"
SHARED DN_TKMTAGQU$:  DN_TKMTAGQU$ = "ASTROLOG\TKMTAGQU.AST"
SHARED DN_TKMTIERK$:  DN_TKMTIERK$ = "ASTROLOG\TKMTIERK.AST"
SHARED DN_WOTAGAST$:  DN_WOTAGAST$ = "ASTROLOG\WOTAGNAM.AST"

SHARED DN_HTML_KAL$:  DN_HTML_KAL$ = "HTML-Kal.htm"
SHARED DN_BAUERNRE$:  DN_BAUERNRE$ = "BAUERNRE.DAT"
SHARED DN_CHRONOLO$:  DN_CHRONOLO$ = "CHRONOLO.DAT"
SHARED DN_FEHLERME$:  DN_FEHLERME$ = "FEHLERME.DAT"
SHARED DN_FERIENLI$:  DN_FERIENLI$ = "FERIENLI.DAT"
SHARED DN_FINSTERN$:  DN_FINSTERN$ = "FINSTERN.DAT"
SHARED DN_FTDATEI$:   DN_FTDATEI$ = "FTDATEI.DAT"
SHARED DN_STDATEI$:   DN_STDATEI$ = "STDATEI.DAT"
SHARED DN_GRIEZAHL$:  DN_GRIEZAHL$ = "GRIEZAHL.DAT"
SHARED DN_HERRSCHE$:  DN_HERRSCHE$ = "HERRSCHE.DAT"
SHARED DN_INFO$:      DN_INFO$ = "INFO.DAT"
SHARED DN_KIRCHENJ$:  DN_KIRCHENJ$ = "KIRCHENJ.DAT"
SHARED DN_KOORDINA$:  DN_KOORDINA$ = "KOORDINA.DAT"
SHARED DN_LEXIKON$:   DN_LEXIKON$ = "LEXIKON.DAT"
SHARED DN_MONATNAM$:  DN_MONATNAM$ = "MONATNAM.DAT"
SHARED DN_JULMONAT$:  DN_JULMONAT$ = "JULMONAT.DAT"
SHARED DN_KOPMONAT$:  DN_KOPMONAT$ = "KOPMONAT.DAT"
SHARED DN_ORBIS$:     DN_ORBIS$ = "ORBIS.DAT"
SHARED DN_PULLDOWN$:  DN_PULLDOWN$ = "PULLDOWN.DAT"
SHARED DN_ROEMZAHL$:  DN_ROEMZAHL$ = "ROEMZAHL.DAT"
SHARED DN_SANKTORA$:  DN_SANKTORA$ = "SANKTORA.DAT"
SHARED DN_SPRUCH$:    DN_SPRUCH$ = "SPRUCH.DAT"
SHARED DN_TKMDATEI$:  DN_TKMDATEI$ = "TKMDATEI.DAT"
SHARED DN_ZAHLGRIE$:  DN_ZAHLGRIE$ = "ZAHLGRIE.DAT"
SHARED DN_ZAHLROEM$:  DN_ZAHLROEM$ = "ZAHLROEM.DAT"
SHARED DN_SPEISEPL$:  DN_SPEISEPL$ = "SPEISEPL.DAT"
SHARED DN_JULBED$:    DN_JULBED$ = "JULBED.DAT"

SHARED DN_SCHIKASE$:  DN_SCHIKASE$ = "SERIELL\SCHIKALP.SER"

SHARED DN_KIJAEVAN$:  DN_KIJAEVAN$ = "KIRCHENJ\EVANGELI\"
SHARED DN_FTAGEING$:  DN_FTAGEING$ = "KIRCHENJ\FTAGEING.KIJ"

SHARED DN_User$:      DN_User$ = "USER\"
SHARED DN_TEXT_TMP$:  DN_TEXT_TMP$ = DN_User$ + "TEXT.TMP"
SHARED DN_SKPUFFER$:  DN_SKPUFFER$ = DN_User$ + "SKPUFFER.TMP"
SHARED DN_ADVENTAG$:  DN_ADVENTAG$ = DN_User$ + "ADVENTAG.DAT"
SHARED DN_BADI$:      DN_BADI$ = DN_User$ + "BADI.DAT"
SHARED DN_BIORHYTH$:  DN_BIORHYTH$ = DN_User$ + "BIORHYTH.DAT"
SHARED DN_CHINA$:     DN_CHINA$ = DN_User$ + "CHINA.DAT"
SHARED DN_DDR$:       DN_DDR$ = DN_User$ + "DDR.DAT"
SHARED DN_EINLAENG$:  DN_EINLAENG$ = DN_User$ + "EINLAENG.DAT"
SHARED DN_FEIERTAG$:  DN_FEIERTAG$ = DN_User$ + "FEIERTAG.DAT"
SHARED DN_ISLAM$:     DN_ISLAM$ = DN_User$ + "ISLAM.DAT"
SHARED DN_JUEDISCH$:  DN_JUEDISCH$ = DN_User$ + "JUEDISCH.DAT"
SHARED DN_KOPTFEI$:   DN_KOPTFEI$ = DN_User$ + "KOPTFEI.DAT"
SHARED DN_KOPTOST$:   DN_KOPTOST$ = DN_User$ + "KOPTOST.DAT"
SHARED DN_NAMENTAG$:  DN_NAMENTAG$ = DN_User$ + "NAMENTAG.DAT"
SHARED DN_ORTHADV$:   DN_ORTHADV$ = DN_User$ + "ORTHADV.DAT"
SHARED DN_ORTHFEI$:   DN_ORTHFEI$ = DN_User$ + "ORTHFEI.DAT"
SHARED DN_ORTHOST$:   DN_ORTHOST$ = DN_User$ + "ORTHOST.DAT"
SHARED DN_OSTERTAG$:  DN_OSTERTAG$ = DN_User$ + "OSTERTAG.DAT"
SHARED DN_PERJAHR$:   DN_PERJAHR$ = DN_User$ + "PERJAHR.DAT"
SHARED DN_PERMONAT$:  DN_PERMONAT$ = DN_User$ + "PERMONAT.DAT"
SHARED DN_PERTAG$:    DN_PERTAG$ = DN_User$ + "PERTAG.DAT"
SHARED DN_PERWOCHE$:  DN_PERWOCHE$ = DN_User$ + "PERWOCHE.DAT"
SHARED DN_SCHIKA2P$:  DN_SCHIKA2P$ = DN_User$ + "SCHIKA2P.DAT"
SHARED DN_SCHIKA3P$:  DN_SCHIKA3P$ = DN_User$ + "SCHIKA3P.DAT"
SHARED DN_SCHIKA4P$:  DN_SCHIKA4P$ = DN_User$ + "SCHIKA4P.DAT"
SHARED DN_SCHIKALA$:  DN_SCHIKALA$ = DN_User$ + "SCHIKALA.DAT"
SHARED DN_SCHIKALM$:  DN_SCHIKALM$ = DN_User$ + "SCHIKALM.DAT"
SHARED DN_SCHIKALP$:  DN_SCHIKALP$ = DN_User$ + "SCHIKALP.DAT"
SHARED DN_SCHIKALW$:  DN_SCHIKALW$ = DN_User$ + "SCHIKALW.DAT"
SHARED DN_UNO_NORM$:  DN_UNO_NORM$ = DN_User$ + "UNO_NORM.DAT"
SHARED DN_UNO_WOTA$:  DN_UNO_WOTA$ = DN_User$ + "UNO_WOTA.DAT"
SHARED DN_WOTAGMON$:  DN_WOTAGMON$ = DN_User$ + "WOTAGMON.DAT"
