SUB FeiertagGreg(JD&, Tag%, Monat%, Jahr&, FTName$, NTName$)
 'Holt einen Namenstag in FTName$
 CALL RandomLesen(DN_FEIERTAG$, Monat% * 100 + Tag%, FTName$, fa&, sr&, Ort%, Ende%, Stelle%, JDN&, c$)
 IF (sr& AND 7) > 1 THEN
   CALL Wochentag(0, 0, 0, JD&, wt%)
   IF wt% = 7 AND (sr& AND 7) = 2 THEN FTName$ = "" 'nicht am Sonntag
   IF wt% <> 1 AND (sr& AND 7) = 4 THEN FTName$ = "" 'nur am Montag
 END IF
 IF (sr& AND 24) = 16 THEN 'Tage entfllt wenn er in die Woche vor oder nach Ostern fllt
   CALL Datum_Kalenderreform(Jahr&, Umstelldatum&)
   IF JD& < Umstelldatum& THEN CALL OstersonntagJul(Jahr&, Ostern%) ELSE CALL OstersonntagGreg(Jahr&, Ostern%)
   CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", Diff&, 0)
   Verkuendigung% = JD& - Diff&
   IF Verkuendigung% >= Ostern% - 7 AND Verkuendigung% <= Ostern% + 7 THEN FTName$ = ""
 END IF
 IF fa& = 0 THEN NTName$ = FTName$: FTName$ = ""
END SUB

SUB Datum_Kalenderreform(Jahr&, Umstelldatum&)
 'DatJulGreg& = Umstellung in der Form "15821004"
 'JDJulGreg&  = Umstellung als Julianischer Tag
 'Wenn die Kalenderumstellung nach dem 1.2. und vor dem 25.6. ist, also in die Ostertage fllt,
 'wird das Jahr noch nach der Julianischen  Osterformel berechnet
 IF Jahr& = FIX(DatJulGreg& / 10000) AND DatJulGreg& - FIX(DatJulGreg& / 10000) * 10000 > 201 AND DatJulGreg& - FIX(DatJulGreg& / 10000) * 10000 < 625 THEN
   UmJahr& = FIX(DatJulGreg& / 10000)
   CALL DatumEingabeUmrechnen(31, 12, UmJahr&, "EJ", Umstelldatum&, 0)
 ELSE
   Umstelldatum& = JDJulGreg&
 END IF
END SUB

SUB FeiertagOsternG(JD&, Tag%, Monat%, Jahr&, FTOstern$, NTOstern$, Diff&)
 CALL Datum_Kalenderreform(Jahr&, Umstelldatum&)
 IF JD& < Umstelldatum& THEN CALL OstersonntagJul(Jahr&, Ostern%) ELSE CALL OstersonntagGreg(Jahr&, Ostern%)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", Diff&, 0)
 CALL RandomLesen(DN_OSTERTAG$, (JD& - Diff&) - Ostern%, FTOstern$, fa&, z2&, Ort%, Ende%, Stelle%, Diff&, c$)
 IF FTOstern$ = "" THEN Diff& = 999: EXIT SUB
 IF fa& = 0 THEN NTOstern$ = FTOstern$: FTOstern$ = ""
END SUB

SUB FeiertagAdventG(JD&, Jahr&, FTAdvent$, NTAdvent$, Diff&)
 '1. Advent = 1. So nach dem 26.11.
 'CALL GregdatumJultage(1, 1, Jahr&, Diff&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", Diff&, 0)
 'CALL GregdatumJultage(27, 11, Jahr&, JD2&)
 CALL DatumEingabeUmrechnen(27, 11, Jahr&, "Datum", JD2&, 0)
 CALL Wochentag(0, 0, 0, JD2&, wt%)
 Advent% = JD2& - Diff& + 7 - wt%
 CALL RandomLesen(DN_ADVENTAG$, (JD& - Diff&) - Advent%, FTAdvent$, fa&, z2&, Ort%, Ende%, Stelle%, Diff&, c$)
 IF FTAdvent$ = "" THEN Diff& = 999: EXIT SUB
 IF fa& = 0 THEN NTAdvent$ = FTAdvent$: FTAdvent$ = ""
END SUB

SUB FeiertagUNO(JD&, UNOTag%, UNOMonat%, UNOJahr&, FTUNO$, fa&)
 'Holt einen Namenstag in FTUNO$
 FTUNO$ = ""
 CALL WotaImMonat(DN_UNO_WOTA$, JD&, UNOTag%, UNOMonat%, UNOJahr&, FTUNO$, Farbe%): IF Farbe% = %weiss THEN fa& = 0 ELSE fa& = 1
 IF FTUNO$ = "" THEN CALL RandomLesen(DN_UNO_NORM$, UNOMonat% * 100 + UNOTag%, FTUNO$, fa&, z2&, Ort%, Ende%, Stelle%, JDN&, c$)
END SUB

SUB WotaImMonat(Pfadname$, JD&, Tag%, Monat%, Jahr&, WoTaMo$, Farbe%)
 CALL Schaltjahr(Tag%, Monat%, Jahr&)
 CALL Wochentag(1, Monat%, Jahr&, 0, wt1%)
 CALL Wochentag(0, 0, 0, JD&, wt%)
 Nummer& = ABS(INT((- Tag% - wt1% + 1) / 7))
 IF wt% < wt1% THEN Nummer& = Nummer& - 1
 Nummer& = Monat% * 100 + Nummer& * 10 + wt%
 CALL RandomLesen(Pfadname$, Nummer&, WoTaMo$, Modus&, fa&, Ort%, Ende%, Stelle%, Diff&, c$)
 IF fa& = 1 THEN Farbe% = %rot ELSE Farbe% = %weiss
 IF Tag% = 7 AND Modus& = 1 THEN WoTaMo$ = ""                    'Nicht wenn es der 7. ist
 IF Tag% <> Monatstage%(Monat%) AND Modus& = 2 THEN WoTaMo$ = "" 'Nur am letzten Tag des Monats
 IF Tag% <> Monatstage%(Monat%) AND Modus& = 2 THEN WoTaMo$ = "" 'Nur am letzten Tag des Monats
 IF Monatstage%(Monat%) - Tag% > 6 AND Tag% > 21 AND Modus& = 3 THEN WoTaMo$ = "" 'Nicht am vorletzten Wochentag des Monats
 IF Modus& = 4 THEN
   CALL OstersonntagGreg(Jahr&, Pfingsten%): Pfingsten% = Pfingsten% + 49
   'CALL GregdatumJultage(1, 1, Jahr&, Diff&)
   CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", Diff&, 0): Diff& = JD& - Diff& + 7
   IF Diff& <> Pfingsten% THEN WoTaMo$ = "" 'Lschen wenn der Pfingsten nicht auf den 2. Sonntag im Mai fllt.
 END IF
END SUB

SUB FeiertagIslam(ITag%, IMonat%, FTMoham$)
 'Holt einen Namenstag in FTMoham$
 CALL RandomLesen(DN_ISLAM$, IMonat% * 100 + ITag%, FTMoham$, z1&, z2&, Ort%, Ende%, Stelle%, JDN&, c$)
END SUB

SUB FeiertagDDR(DDRTag%, DDRMonat%, FTDDR$, fa&)
 'Holt einen Namenstag in FTDDR$
 CALL RandomLesen(DN_DDR$, DDRMonat% * 100 + DDRTag%, FTDDR$, fa&, z2&, Ort%, Ende%, Stelle%, JDN&, c$)
END SUB

SUB FeiertagBadi(BaTag%, BaMonat%, FTBadi$)
 'Holt einen Namenstag in FTChin$
 CALL RandomLesen(DN_BADI$, BaMonat% * 100 + BaTag%, FTBadi$, z1&, z2&, Ort%, Ende%, Stelle%, JDN&, c$)
END SUB

SUB FeiertagChin(ChTag%, ChMonat%, FTChin$)
 'Holt einen Namenstag in FTChin$
 CALL RandomLesen(DN_CHINA$, ChMonat% * 100 + ChTag%, FTChin$, z1&, z2&, Ort%, Ende%, Stelle%, JDN&, c$)
END SUB

SUB FeiertagJued(Tag%, Monat%, wt%, JL%, JFName$)
 'Modus =   16 = Nur am Donnerstag"
 '      =   64 = Keine Fasttage am Sabbat"
 '      =  128 = Nur am Sonntag"
 '      =  256 = Im Schaltjahr nicht im Adar"
 '      =  512 = Nicht im mangelhaften Jahr"
 '      = 1024 = Nur im mangelhaften Jahr"
 CALL RandomLesen(DN_JUEDISCH$, Monat% * 100 + Tag%, JFName$, z1&, z2&, Ort%, Ende%, Stelle%, JDN&, c$)
 wv% = z1&
 IF wt% <> 4 AND (wv% AND 16) = 16 THEN JFName$ = ""                      'Nur am Donnerstag
 IF wt% = 6 AND (wv% AND 64) = 64 THEN JFName$ = ""                       'Keine Fasttage am Sabbat
 IF wt% <> 7 AND (wv% AND 128) = 128 THEN JFName$ = ""                    'Nur am Sonntag
 IF JL% > 382 AND (wv% AND 256) = 256 THEN JFName$ = ""                   'Im Schaltjahr nicht im Adar
 IF (JL% = 383 OR JL% = 353) AND (wv% AND 512) = 512 THEN JFName$ = ""    'Nicht im mangelhaften Jahr
 IF JL% <> 383 AND JL% <> 353 AND (wv% AND 1024) = 1024 THEN JFName$ = "" 'Nur im mangelhaften Jahr
END SUB

SUB FeiertagOrth(JTag%, JMonat%, FTJul$)
 'Holt einen Namenstag in FTJul$
 CALL RandomLesen(DN_ORTHFEI$, JMonat% * 100 + JTag%, FTJul$, z1&, z2&, Ort%, Ende%, Stelle%, JDN&, c$)
END SUB

SUB FeiertagOsternJ(JD&, Tag%, Monat%, Jahr&, FTOstern$)
 CALL OsterSonntagJul(Jahr&, Ostern%)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", Diff&, 0)
 CALL RandomLesen(DN_ORTHOST$, (JD& - Diff&) - Ostern%, FTOstern$, z1&, z2&, Ort%, Ende%, Stelle%, Diff&, c$)
 IF FTOstern$ = "" THEN Diff& = 999
END SUB

SUB FeiertagAdventJ(JD&, Jahr&, FTAdvent$, Diff&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", Diff&, 0)
 CALL DatumEingabeUmrechnen(27, 11, Jahr&, "EJ", JD2&, 0)
 CALL Wochentag(0, 0, 0, JD2&, wt%)
 Advent% = JD2& - Diff& +7 - wt%
 CALL RandomLesen(DN_ORTHADV$, (JD& - Diff&) - Advent%, FTAdvent$, z1&, z2&, Ort%, Ende%, Stelle%, Diff&, c$)
 IF FTAdvent$ = "" THEN Diff& = 999
END SUB

SUB FeiertagKopt(Tag%, Monat%, FTKop$)
 CALL RandomLesen(DN_KOPTFEI$, Monat% * 100 + Tag%, FTKop$, z1&, z2&, Ort%, Ende%, Stelle%, JDN&, c$)
END SUB

SUB FeiertagOsternK(JD&, Tag%, Monat%, Jahr&, FTOstern$)
 CALL OsterSonntagJul(Jahr&, Ostern%)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", Diff&, 0)
 CALL RandomLesen(DN_KOPTOST$, (JD& - Diff&) - Ostern%, FTOstern$, z1&, z2&, Ort%, Ende%, Stelle%, Diff&, c$)
 IF FTOstern$ = "" THEN Diff& = 999
END SUB

SUB FeiertagEingabeMaske(Pfadname$, Kopftext$, Datumtext$, Datumbezug$, NamTag&, Test%)
 diainputsize% = %NamTagLaenge 'sichbare Eingabelnge
 Test% = 0: pFarbe% = 1: Farbe$ = "Rot:Weiss"
 CALL RandomLesen(Pfadname$, NamTag&, Text$, fa&, z2&, Ort%, Ende%, a%, b&, c$)
 IF Text$ <> "" THEN
   IF fa& = 1 THEN pFarbe% = 1 ELSE pFarbe% = 2
 END IF
 CALL diawin(2, Spalte%, 12, 43, Kopftext$, %ON)
 CALL diaprint(2, 2, Datumtext$ + Datumbezug$)
 CALL diainp(4, 2, "Feiertag......:", 4, 18, %NamTagLaenge, Text$)
 CALL diaradio(6, 2, "Textfarbe.....:", 6, 18, Farbe$, pFarbe%)
 CALL diapush(9, 29, "bernehmen")
 CALL diapush(9, 2, "Abbruch")
 CALL diapush(9, 15, "Lschen")
 CALL diaset(1)
 DO
   d% = dialog
   l% = lastkeyx
   IF l% = %ESC OR d% = 4 THEN
     Test% = 0 : CALL diaclose : mouseon : EXIT SUB
   ELSEIF d% = 3 AND l% = %ENTER THEN
     IF Text$ = "" THEN CALL Fehlermeldung("77") ELSE EXIT LOOP
   ELSEIF d% = 5 AND Text$ <>"" THEN
     CALL RandomLoeschen(Pfadname$, NamTag&, Text$): Test% = 1 : CALL diaclose : mouseon : EXIT SUB
   END IF
 LOOP
 CALL diaclose : mouseon
 IF pFarbe% = 1 THEN fa& = 1 ELSE fa& = 0
 CALL RandomEinfuegen(Pfadname$, NamTag&, Text$, fa&, z2&)
 Test% = 1
END SUB

SUB FeiertagEingabeMaskeNormal(Pfadname$, Kopftext$, Datumtext$, Datumbezug$, NamTag&, Test%)
 diainputsize% = %NamTagLaenge 'sichbare Eingabelnge
 Test% = 0: pFarbe% = 1
 Farbe$ = "Rot:Weiss"
 Auswahl$ = "immer:nicht am Sonntag:nur am Montag"
 Auswahl2$ = "keine Konsequenzen:keine Anzeige"
 CALL RandomLesen(Pfadname$, NamTag&, Text$, fa&, sr&, Ort%, Ende%, a%, b&, c$)
 IF Text$ <> "" THEN
   IF fa& = 1 THEN pFarbe% = 1 ELSE pFarbe% = 2
 END IF
 SELECT CASE sr& AND 7
   CASE 0, 1: pModus% = 1
   CASE 2: pModus% = 2
   CASE 4: pModus% = 3
 END SELECT
 SELECT CASE sr& AND 24
   CASE 0, 8: pModus2% = 1
   CASE 16: pModus2% = 2
 END SELECT

 CALL diawin(2, Spalte%, 20, 48, Kopftext$, %ON)
 CALL diaprint(2, 2, Datumtext$ + Datumbezug$)
 CALL diainp(4, 2, "Feiertag......:", 4, 18, %NamTagLaenge, Text$)
 CALL diaradio(6, 2, "Textfarbe.....:", 6, 18, Farbe$, pFarbe%)
 CALL diaradio(9, 2, "Anzeige.......:", 9, 18, Auswahl$, pModus%)
 CALL diaprint(13, 2, "Wenn in der Woche vor oder nach Ostern dann")
 CALL diaradio(14, 11, " ", 14, 11, Auswahl2$, pModus2%)
 CALL diapush(17, 33, "bernehmen")
 CALL diapush(17, 2, "Abbruch")
 CALL diapush(17, 17, "Lschen")
 CALL diaset(1)
 DO
   d% = dialog
   l% = lastkeyx
   IF l% = %ESC OR d% = 6 THEN
     Test% = 0 : CALL diaclose : mouseon : EXIT SUB
   ELSEIF d% = 5 AND l% = %ENTER THEN
     IF Text$ = "" THEN CALL Fehlermeldung("77") ELSE EXIT LOOP
   ELSEIF d% = 7 AND Text$ <> "" THEN
     CALL RandomLoeschen(Pfadname$, NamTag&, Text$): Test% = 1 : CALL diaclose : mouseon : EXIT SUB
   END IF
 LOOP
 CALL diaclose : mouseon
 IF pFarbe% = 1 THEN fa& = 1 ELSE fa& = 0
 sr& = 0
 BIT SET sr&, pModus% - 1
 BIT SET sr&, pModus2% + 2
 CALL RandomEinfuegen(Pfadname$, NamTag&, Text$, fa&, sr&)
 Test% = 1
END SUB

SUB FremdFeiertagEingabe(Pfadname$, Kopftext$, Datumtext$, Datumbezug$, NamTag&, Test%)
 diainputsize% = %NamTagLaenge 'sichbare Eingabelnge
 Test% = 0
 CALL RandomLesen(Pfadname$, NamTag&, Text$, z1&, z2&, Ort%, Ende%, a%, b&, c$)
 CALL diawin(2, Spalte%, 9, 43, Kopftext$, %ON)
 CALL diaprint(2, 2, Datumtext$ + Datumbezug$)
 CALL diainp(4, 2, "Feiertag......:", 4, 18, %NamTagLaenge, Text$)
 CALL diapush(6, 29, "bernehmen")
 CALL diapush(6, 2, "Abbruch")
 CALL diapush(6, 15, "Lschen")
 CALL diaset(1)
 DO
   d% = dialog
   l% = lastkeyx
   IF l% = %ESC OR d% = 3 THEN
     Test% = 0 : CALL diaclose : mouseon : EXIT SUB
   ELSEIF d% = 2 AND l% = %ENTER THEN
     IF Text$ = "" THEN CALL Fehlermeldung("77") ELSE EXIT LOOP
   ELSEIF d% = 4 AND Text$ <>"" THEN
     CALL RandomLoeschen(Pfadname$, NamTag&, Text$): Test% = 1 : CALL diaclose : mouseon : EXIT SUB
   END IF
 LOOP
 CALL diaclose : mouseon
 CALL RandomEinfuegen(Pfadname$, NamTag&, Text$, z1&, z2&)
 Test% = 1
END SUB


SUB FeiertagEingabe(JD&, Test%, Modus%)
 IF Modus% = 0 THEN Pfadname$ = DN_FEIERTAG$: Kopftext$ = " Feiertag "
 IF Modus% = 1 THEN Pfadname$ = DN_DDR$: Kopftext$ = " DDR - Feiertag "
 IF Modus% = 2 THEN Pfadname$ = DN_UNO_NORM$: Kopftext$ = " UNO - Feiertag "
 CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
 CALL LeseMonatsname("STANDARD.MON", Monat%, Monatsname$, 0)
 IF LEN(Monatsname$) > 19 THEN Monatsname$ = LEFT$(Monatsname$, 19)
 Datum$ = LTRIM$(STR$(Tag%)) + ". " + Monatsname$
 NamTag& = Monat% * 100 + Tag%
 IF Modus% = 0 THEN CALL FeiertagEingabeMaskeNormal(Pfadname$, Kopftext$, "Datum.........: ", Datum$, NamTag&, Test%)
 IF Modus% THEN CALL FeiertagEingabeMaske(Pfadname$, Kopftext$, "Datum.........: ", Datum$, NamTag&, Test%)
END SUB

SUB OstertagEingabe(JD&, Test%)
 CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
 CALL LeseMonatsname("STANDARD.MON", Monat%, Monatsname$, 0)
 IF LEN(Monatsname$) > 19 THEN Monatsname$ = LEFT$(Monatsname$, 19)
 Datum$ = LTRIM$(STR$(Tag%)) + ". " + Monatsname$

 IF Jahr& = FIX(DatJulGreg& / 10000) AND DatJulGreg& - FIX(DatJulGreg& / 10000) * 10000 > 201 AND DatJulGreg& - FIX(DatJulGreg& / 10000) * 10000 < 625 THEN
   UmJahr& = FIX(DatJulGreg& / 10000)
   CALL DatumEingabeUmrechnen(31, 12, UmJahr&, "EJ", Umstelldatum&, 0)
 ELSE
   Umstelldatum& = JDJulGreg&
 END IF

 IF JD& < Umstelldatum& THEN CALL OstersonntagJul(Jahr&, Ostern%) ELSE CALL OstersonntagGreg(Jahr&, Ostern%)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", Diff&, 0)
 OstTag& = (JD& - Diff&) - Ostern%
 IF OstTag& < 0 THEN a$ = "-" ELSE a$ = "+"
 Datumbezug$ = a$ + STR$(ABS(OstTag&)) + " Tage"
 CALL FeiertagEingabeMaske(DN_OSTERTAG$, " Ostertage ", "Ostersonntag..: ", Datumbezug$, OstTag&, Test%)
 END SUB

SUB AdventtagEingabe(JD&, Test%)
 CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", Diff&, 0)
 CALL DatumEingabeUmrechnen(27, 11, Jahr&, "Datum", JD2&, 0)
 CALL Wochentag(0, 0, 0, JD2&, wt%)
 AdvTag& = (JD& - Diff&) - (JD2& - Diff& + 7 - wt%)
 IF AdvTag& < 0 THEN a$ = "-" ELSE a$ = "+"
 Datumbezug$ = a$ + STR$(ABS(AdvTag&)) + " Tage"
 CALL FeiertagEingabeMaske(DN_ADVENTAG$, " Adventtag ", "1. Advent.....: ", Datumbezug$, AdvTag&, Test%)
END SUB

SUB WoTagMonEingabe(JD&, Test%)
 diainputsize% = %NamTagLaenge 'sichbare Eingabelnge
 Test% = 0: pFarbe% = 1
 Regel$ = "Keine:Nicht wenn es der 7. Tag im Monat ist:Nur wenn es der letzte Tag im Monat ist:Nicht wenn es der vorletzte Wochentag im Monat ist:Nur wenn Pfingsten auf den 2. Sonntag im Mai fllt"
 Farbe$ = "Rot:Weiss"
 CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
 CALL Schaltjahr(Tag%, Monat%, Jahr&)
 CALL Wochentag(1, Monat%, Jahr&, 0, wt1%)
 CALL Wochentag(0, 0, 0, JD&, wt%)
 pNummer% = ABS(INT((- Tag% - wt1% + 1) / 7))
 IF wt% < wt1% THEN pNummer% = pNummer% - 1
 Nummer& = Monat% * 100 + pNummer% * 10 + wt%
 CALL RandomLesen(DN_WOTAGMON$, Nummer&, Text$, Modus&, fa&, Ort%, Ende%, Stelle%, Diff&, c$)
 IF Text$ <> "" THEN
   IF fa& < 2 THEN pFarbe% = 1 ELSE pFarbe% = 2
 END IF
 pRegel% = Modus& + 1
 CALL LeseMonatsname("STANDARD.MON", Monat%, Monatsname$, 0)
 IF LEN(Monatsname$) > 19 THEN Monatsname$ = LEFT$(Monatsname$, 19)
 a$ = LTRIM$(STR$(pNummer%)) + ". " + Tagesname$(wt%) + " im " + Monatsname$
 CALL diawin(2, Spalte%, 18, 76, " Wochentag im Monat ", %ON)
 CALL diaprint(2, 2, a$)
 CALL diainp(4, 2, "Feiertag......:", 4, 18, %NamTagLaenge, Text$)
 CALL diaradio(6, 2, "Sonderregel...:", 6, 18, Regel$, pRegel%)
 CALL diaradio(12, 2, "Textfarbe.....:", 12, 18, Farbe$, pFarbe%)
 CALL diapush(15, 62, "bernehmen")
 CALL diapush(15, 2, "Abbruch")
 CALL diapush(15, 33, "Lschen")
 CALL diaset(1)
 DO
   d% = dialog
   l% = lastkeyx
   IF l% = %ESC OR d% = 5 THEN
     Test% = 0 : CALL diaclose : mouseon : EXIT SUB
   ELSEIF d% = 4 AND l% = %ENTER THEN
     IF Text$ = "" THEN CALL Fehlermeldung("77") ELSE EXIT LOOP
   ELSEIF d% = 6 AND Text$ <>"" THEN
     CALL RandomLoeschen(DN_WOTAGMON$, Nummer&, Text$): Test% = 1 : CALL diaclose : mouseon : EXIT SUB
   END IF
 LOOP
 CALL diaclose : mouseon
 Modus& = pRegel% - 1
 fa& = pFarbe%
 CALL RandomEinfuegen(DN_WOTAGMON$, Nummer&, Text$, Modus&, fa&)
 Test% = 1
END SUB

SUB IslamEingabe(JD&, Test%)
 CALL JultageMoham(JD&, Tag%, Monat%, Jahr&)
 CALL LeseMonatsname("ISLAM.MON", Monat%, Mohamname$, 0)
 Datum$ = LTRIM$(STR$(Tag%) + ". " + Mohamname$)
 NamTag& = Monat% * 100 + Tag%
 CALL FremdFeiertagEingabe(DN_ISLAM$, " Islamischer Feiertag ", "Datum.........: ", Datum$, NamTag&, Test%)
END SUB

SUB BadiEingabe(JD&, Test%)
 CALL JultageBadidatum (JD&, Tag%, Monat%, Jahr&, Vahid%, Kull%)
 NamTag& = Monat% * 100 + Tag%
 IF Monat% = 19 THEN Monat% = 0
 IF Monat% = 20 THEN Monat% = 19
 Datum$ = LTRIM$(STR$(Tag%)) + "." + LTRIM$(STR$(Monat%)+ ".")
 CALL FremdFeiertagEingabe(DN_BADI$, " Bad - Bah' Feiertag", "Datum.........: ", Datum$, NamTag&, Test%)
END SUB

SUB ChinaEingabe(JD&, Test%)
 CALL JultageChinesisch(JD&, Tag%, Monat%, ZyklusJahr%, Zyklus%, TierJahr%, ErdeJahr%, TierTag%, ErdeTag%)
 Datum$ = LTRIM$(STR$(Tag%)) + "." + LTRIM$(STR$(Monat%))
 NamTag& = Monat% * 100 + Tag%
 CALL FremdFeiertagEingabe(DN_CHINA$, " Chinesischer Feiertag ", "Datum.........: ", Datum$, NamTag&, Test%)
END SUB

SUB JuedischEingabe(JD&, Test%)
 diainputsize% = %NamTagLaenge 'sichbare Eingabelnge
 Test% = 0
 Auswahl$ = "Keine Sabbatregel:Nur am Donnerstag:Nicht am Sabbat:Nur am Sonntag"
 Auswahl2$= "Keine Schaltjahrregel:Im Schaltjahr nicht im Adar"
 Auswahl3$= "Keine Jahresregel:Nicht im mangelhaften Jahr:Nur im mangelhaften Jahr"

 CALL JultageJuddatum(JD&, Tag%, Monat%, Jahr&, JL%)
 CALL LeseMonatsname("JUEDISCH.MON", Monat%, Judname$, 0)
 Datum$ = LTRIM$(STR$(Tag%)) + "." + Judname$
 CALL RandomLesen(DN_JUEDISCH$, Monat% * 100 + Tag%, Text$, Modus&, z2&, Ort%, Ende%, a%, b&, c$)
 SELECT CASE Modus& AND 255
   CASE 0: pModus% = 1
   CASE 16: pModus% = 2
   CASE 64: pModus% = 3
   CASE 128: pModus% = 4
 END SELECT
 IF Modus& AND 256 = 256 THEN pModus2% = 2 ELSE pModus2% = 0
 SELECT CASE Modus& AND (2047 - 511)
   CASE 0: pModus3% = 1
   CASE 512: pModus3% = 2
   CASE 1024: pModus3% = 3
 END SELECT
 CALL diawin(2, Spalte%, 21, 53, " Jdischer Feiertag ", %ON)
 CALL diaprint(2, 2, "Datum.........: " + Datum$)
 CALL diainp(4, 2, "Bezeichnung...:", 4, 18, %NamTagLaenge, Text$)
 CALL diaradio(6, 2, "Sabbat........: ", 6, 18, Auswahl$, pModus%)
 CALL diaradio(11, 2, "Schaltmonat...: ",11, 18, Auswahl2$, pModus2%)
 CALL diaradio(14, 2, "Jahr..........: ",14, 18, Auswahl3$, pModus3%)
 CALL diapush(18, 39, "bernehmen")
 CALL diapush(18, 2, "Abbruch")
 CALL diapush(18, 20, "Lschen")
 CALL diaset(1)
 DO
   d% = dialog
   l% = lastkeyx
   IF l% = %ESC OR d% = 6 THEN
     Test% = 0 : CALL diaclose : mouseon : EXIT SUB
   ELSEIF d% = 5 AND l% = %ENTER THEN
     IF Text$ = "" THEN CALL Fehlermeldung("77") ELSE EXIT LOOP
   ELSEIF d% = 7 AND Text$ <> "" THEN
     CALL RandomLoeschen(DN_JUEDISCH$, Monat% * 100 + Tag%, Text$): Test% = 1 : CALL diaclose : mouseon : EXIT SUB
   END IF
 LOOP
 CALL diaclose : mouseon
 SELECT CASE pModus%
   CASE 1: Modus& = 0
   CASE 2: Modus& = 16
   CASE 3: Modus& = 64
   CASE 4: Modus& = 128
 END SELECT
 IF pModus2% = 2 THEN Modus& = Modus& + 256
  SELECT CASE pModus3%
   CASE 2: Modus& = Modus& + 512
   CASE 3: Modus& = Modus& + 1024
 END SELECT
 CALL RandomEinfuegen(DN_JUEDISCH$, Monat% * 100 + Tag%, Text$, Modus&, z2&)
 Test% = 1
END SUB

SUB OrthodoxeFeiertagEingabe(JD&, Test%)
 CALL JultageJuldatum(JD&, Tag%, Monat%, Jahr&):
 CALL LeseMonatsname("STANDARD.MON", Monat%, Monatsname$, 0)
 IF LEN(Monatsname$) > 19 THEN Monatsname$ = LEFT$(Monatsname$, 19)
 Datum$ = LTRIM$(STR$(Tag%)) + ". " + Monatsname$ + " Julianisch"
 NamTag& = Monat% * 100 + Tag%
 CALL FremdFeiertagEingabe(DN_ORTHFEI$, " Orthodoxer Feiertag ", "Datum.........: ", Datum$, NamTag&, Test%)
END SUB

SUB OrthodoxeOstertagEingabe(JD&, Test%)
 CALL JultageJuldatum(JD&, Tag%, Monat%, Jahr&)
 CALL OstersonntagJul(Jahr&, Ostern%)
 'CALL JuldatumJultage(1, 1, Jahr&, Diff&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", Diff&, 0)
 OstTag& = (JD& - Diff&) - Ostern%
 IF OstTag& < 0 THEN a$ = "-" ELSE a$ = "+"
 Datum$ = a$ + STR$(ABS(OstTag&)) + " Tage"
 CALL FremdFeiertagEingabe(DN_ORTHOST$, " Orthodoxe Ostertage ", "Ostersonntag..: ", Datum$, OstTag&, Test%)
END SUB

SUB OrthodoxerAdventtagEingabe(JD&, Test%)
 CALL JultageJuldatum(JD&, Tag%, Monat%, Jahr&)
 'CALL JuldatumJultage(1, 1, Jahr&, Diff&)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", Diff&, 0)
 'CALL JuldatumJultage(27, 11, Jahr&, JD2&)
 CALL DatumEingabeUmrechnen(27, 11, Jahr&, "EJ", JD2&, 0)
 CALL Wochentag(0, 0, 0, JD2&, wt%)
 AdvTag& = (JD& - Diff&) - (JD2& - Diff& + 7 - wt%)
 IF AdvTag& < 0 THEN a$ = "-" ELSE a$ = "+"
 Datum$ = a$ + STR$(ABS(AdvTag&)) + " Tage"
 CALL FremdFeiertagEingabe(DN_ORTHADV$, " Orthodoxe Adventtage ", "1. Advent.....: ", Datum$, AdvTag&, Test%)
END SUB

SUB KoptischeFeiertagEingabe(JD&, Test%)
 CALL JultageKoptdatum(JD&, Tag%, Monat%, Jahr&)
 CALL LeseMonatsname("KOPTISCH.MON", Monat%, Koptname$, 0)
 Datum$ = LTRIM$(STR$(Tag%) + ". " + Koptname$)
 NamTag& = Monat% * 100 + Tag%
 CALL FremdFeiertagEingabe(DN_KOPTFEI$, " Koptische Feiertage ", "Datum.........: ", Datum$, NamTag&, Test%)
END SUB

SUB KoptischeOstertagEingabe(JD&, Test%)
 CALL JultageJuldatum(JD&, Tag%, Monat%, Jahr&)
 CALL OstersonntagJul(Jahr&, Ostern%)
 CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", Diff&, 0)
 OstTag& = (JD& - Diff&) - Ostern%
 IF OstTag& < 0 THEN a$ = "-" ELSE a$ = "+"
 Datum$ = a$ + STR$(ABS(OstTag&)) + " Tage"
 CALL FremdFeiertagEingabe(DN_KOPTOST$, " Koptische Ostertage ", "Ostersonntag..: ", Datum$, OstTag&, Test%)
END SUB

SUB Kirchenjahr(JD&, Tag%, Monat%, Jahr&, y%, Text$, Text2$, Modus%)
  'Modus% <> 0 = Langtextausgabe
  'Modus = 2 = Langtext im Text$ ohne extra Fenster
  Text$ = "": Text2$ = ""
  IF Tag% = 0 THEN CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&) 'Fr die Evangelien Langtextausgabe
  SELECT CASE Festjahr%
    CASE 1 TO 5
      CALL LeseDateiName(DN_KIRCHENJ$, Festjahr%, Pfadname$)
    CASE 6
      CALL LeseDateiName(DN_KIRCHENJ$, (ABS(Jahr&) MOD 3) + 6, Pfadname$) 'Lesejahr
  END SELECT

  CALL DatumEingabeUmrechnen(1, 1, Jahr&, "Datum", Diff&, 0)
  TagImJahr% = JD& - Diff&

  CALL DatumEingabeUmrechnen(7, 1, Jahr&, "Datum", JD2&, 0)
  CALL Wochentag(0, 0, 0, JD2&, wt%)
  Epiphanias% = JD2& - Diff& + 7 - wt%

  CALL Datum_Kalenderreform(Jahr&, Umstelldatum&)
  IF JD& < Umstelldatum& THEN CALL OstersonntagJul(Jahr&, Ostern%) ELSE CALL OstersonntagGreg(Jahr&, Ostern%)

  CALL DatumEingabeUmrechnen(27, 11, Jahr&, "Datum", JD2&, 0)
  CALL Wochentag(0, 0, 0, JD2&, wt%)
  Advent% = JD2& - Diff& + 7 - wt%

  IF Festjahr% <> 7 THEN
    OPEN Pfadname$ FOR INPUT AS #1
    WHILE NOT EOF(1)
      INPUT #1, a$, Nummer%, b$
      IF a$ = "e" AND Nummer% + Epiphanias% = TagImJahr% THEN Text$ = b$
      IF a$ = "o" AND Nummer% + Ostern% = TagImJahr% THEN Text$ = b$
      IF a$ = "a" AND Nummer% + Advent% = TagImJahr% THEN Text$ = b$
      IF a$ = "j" OR LEFT$(a$, 1)= "w" OR LEFT$(a$, 1) = "v" THEN
        SELECT CASE Festjahr%
          CASE 3
            CALL JultageGregorian(JD&, tm%, gm%, 0) 'Das Missale soll mit dem gregorianischen Kalender korrespondieren
          CASE 4
            CALL JultageJuldatum(JD&, tm%, gm%, 0) 'Der Lorscher soll mit dem julianischen Kalender korrespondieren
          CASE ELSE
            tm% = Tag%: gm% = Monat%
        END SELECT

        'Schaltjahr
        IF gm% = 2 AND tm% > 23 THEN
          IF Festjahr% = 3 AND Jahr& MOD 100 = 0 AND Jahr& MOD 400 <> 0 THEN Monatstage%(2) = 28 'Missale
          IF Festjahr% = 4 AND Jahr& MOD 4 = 0 THEN Monatstage%(2) = 29 'Lorscher
          IF Festjahr% < 3 OR Festjahr% > 4 THEN CALL Schaltjahr(Tag%, Monat%, Jahr&) 'Alle anderen
          IF Monatstage%(2) = 29 THEN
            IF tm% = 24 THEN b$ = "Bissextum"
            IF tm% > 24 THEN tm% = tm% - 1
          END IF
        END IF

        IF Nummer% = gm% * 100 + tm% THEN
          IF LEFT$(a$, 1)= "w" OR a$ = "v1" THEN 'Text nur an einen bestimmten Wochentag
            CALL Wochentag(0, 0, 0, JD&, wt%)
            IF wt% = VAL(MID$(a$, 2, 1)) THEN Text$ = b$
          ELSE
             Text$ = b$
          END IF
        END IF
      END IF

      'Verkndigung des Herrn fllt in die letzte Fasten- oder 1. Osterwoche
      IF a$ = "v" THEN
        CALL DatumEingabeUmrechnen(25, 3, Jahr&, "Datum", JD2&, 0)
        Verkuendigung% = JD2& - Diff&
        IF Verkuendigung% >= Ostern% - 7 AND Verkuendigung% <= Ostern% + 7 THEN
          IF Nummer% + Ostern% = TagImJahr% THEN Text$ = b$
        END IF
      END IF

    WEND
    CLOSE #1
  END IF

  'Missale erste Zeile
  IF Festjahr% = 3 AND y% = 4 THEN
    CALL EpakteGreg(Jahr&, epg%, gz%)
    IF epg% = 25 AND gz% > 11 THEN
      ep$ = "25"
    ELSEIF epg% = 19 AND gz% = 19 THEN
      ep$ = "19 xix"
    ELSE
      CALL ZahlRoemisch (epg%, ep$, 1)
      IF ep$ <> "*" THEN ep$ = LCASE$(ep$)
    END IF
    CALL Sonntagsbuchstabe(Jahr&, "EI", sb$)
    Text2$ = "Epakte = " + ep$ + "  Sonntagsbuchstabe = " + sb$
  END IF

  'Calendarium perpetuum
  IF Festjahr% = 4 AND y% = 4 THEN
    CALL EpakteJul(Jahr&, Epakte%, gz%)
    CALL WTKonkurrent(Jahr&, "EJ", ko$)
    CALL Sonntagsbuchstabe(Jahr&, "EJ", sb$)
    Text2$ = "SB = " + sb$ + ", WT = " + ko$ + ", GZ =" + STR$(gz%) + ", jul."
  END IF

  'Speiseplan
  IF Festjahr% = 7 THEN CALL LeseSpeiseplan(JD&, Monat%, Text$)

  'Evangeliumstext
  IF Festjahr% = 6 AND Modus% = 0 THEN CALL AufbereitungHerrscher(Text$)

  IF Modus% AND Modus% <> 2 AND Text$ <> "" AND Festjahr% <> 3 AND Festjahr% <> 4 THEN 'Langtextausgabe nicht bei Missale und Lorscher
    IF Festjahr% = 6 THEN
      dn$ = UCASE$(LEFT$(Text$, 16))
      REPLACE " " WITH "" IN dn$
      REPLACE "," WITH "" IN dn$
      REPLACE "." WITH "" IN dn$
      REPLACE ";" WITH "" IN dn$
      REPLACE "-" WITH "" IN dn$
      REPLACE "JOH" WITH "JH" IN dn$
      IF LEN(dn$) > 8 THEN dn$ = LEFT$(dn$, 8)
      OPEN DN_KIJAEVAN$ + dn$ + ".KIJ" FOR INPUT AS #2
      WHILE NOT EOF(2)
        LINE INPUT #2, Text$
        CALL TextAufbereitung(Text$, 76, x%, Zeile%, me%)
        IF NOT me% THEN me% = 1
      WEND
      CLOSE #2
    ELSE
      CALL TextAufbereitung(Text$, 76, x%, Zeile%, 0)
    END IF
    CALL InfoTextAusgabe(" Langtext ", x% , Zeile%, 0)
  ELSE
    IF Festjahr% > 3 AND Modus% <> 2 AND LEN(Text$) > 39 THEN Text$ = LEFT$(Text$, 38) + CHR$(16) 'Ausgabe auf der rechten Seite, Kirchenjahre werden extra bearbeitet.
  END IF
END SUB

SUB LiturgischeFarbe(a$, Farbe%)
  Farbe% = 0
  IF INSTR(a$, "<grn>") THEN REPLACE "<grn>" WITH "" IN a$: Farbe% = 16 * %HGrund + %hgruen
  IF INSTR(a$, "<wei>") THEN REPLACE "<wei>" WITH "" IN a$: Farbe% = 16 * %HGrund + %weiss
  IF INSTR(a$, "<rot>") THEN REPLACE "<rot>" WITH "" IN a$: Farbe% = 16 * %HGrund + %hrot
  IF INSTR(a$, "<schwarz>") THEN REPLACE "<schwarz>" WITH "" IN a$: Farbe% = 16 * %HGrund + %grau
  IF INSTR(a$, "<violett>") THEN REPLACE "<violett>" WITH "" IN a$: Farbe% = 16 * %HGrund + %purpur
  IF INSTR(a$, "<rosa>") THEN REPLACE "<rosa>" WITH "" IN a$: Farbe% = 16 * %HGrund + %hpurpur
  a$ = TRIM$(a$)
  IF LEN(a$) > 38 THEN a$ = LEFT$(a$, 37) + CHR$(16)
END SUB


  