SUB JahresChronologie(JD&)
  CALL JultageGregdatum (JD&, 0, 0, Jahr&)
  LJahr$ = LTRIM$(STR$(ABS(Jahr&)))
  Text$ = LJahr$
  LJahr$ = REPEAT$(4 - LEN(LJahr$), "0") + LJahr$
  IF Jahr& < 0 THEN LJahr$ = "-" + LJahr$
  IF Jahr& > 1582 THEN
    CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EI", JDO&, 0)
    CALL OstersonntagGreg(Jahr&, Ostersonntag%)
    CALL JultageGregorian (JDO& + Ostersonntag%, OTag%, OMonat%, 0)
    CALL LeseMonatsname("STANDARD.MON", OMonat%, OMonatname$, 0)
    Text$ = "Ostern gregorianisch: " + USING$("##_._ ", OTag%) + OMonatname$
    CALL TextAufbereitung(Text$, 76, x%, y%, Modus%): Modus% = 1
  END IF

  CALL DatumEingabeUmrechnen(1, 1, Jahr&, "EJ", JDO&, 0)
  CALL OstersonntagJul(Jahr&, Ostersonntag%)
  CALL JultageJuldatum (JDO& + Ostersonntag%, JOTag%, JOMonat%, 0)
  Text$ = "Ostern julianisch...: "
  CALL LeseMonatsname("STANDARD.MON", JOMonat%, JOMonatname$, 0)
  a$ = USING$("##_._ ", JOTag%) + JOMonatname$
  IF Jahr& > 1582 THEN
    CALL JultageGregorian (JDO& + Ostersonntag%, OTag%, OMonat%, 0)
    CALL LeseMonatsname("STANDARD.MON", OMonat%, OMonatname$, 0)
    Text$ = Text$ + USING$("##_._ ", OTag%) + OMonatname$ + " (" + a$ + " julianisch)"
  ELSE
    Text$ = Text$ + a$
  END IF
  CALL TextAufbereitung(Text$, 76, x%, y%, Modus%): Modus% = 1

  CALL JultageJuddatum (JDO&, 0, 0, JJahr&, 0)
  CALL DatumEingabeUmrechnen(15, 8, JJahr&, "EH", Pessach&, 0)
  CALL JultageGregdatum (Pessach&, OTag%, OMonat%, 0)
  CALL LeseMonatsname("STANDARD.MON", OMonat%, OMonatname$, 0)
  Text$ = "Pessach.............: " + USING$("##_._ ", OTag%) + OMonatname$ + " (15. Nissan" + STR$(JJahr&) + ")<br>"
  CALL TextAufbereitung(Text$, 76, x%, y%, Modus%)

  SGRJahr& = Jahr&: IF SGRJahr& < 1 THEN SGRJahr& = SGRJahr& + 1
  SZahl% = (SGRJahr& + 9 ) MOD 28
  IF SZahl% < 1 THEN SZahl% = SZahl% + 28
  CALL TextAufbereitung("Sonnenzirkel.:" + USING$("_ ##", SZahl%), 76, x%, y%, Modus%)
  GZahl% = (SGRJahr& + 1) MOD 19
  IF GZahl% < 1 THEN GZahl% = GZahl% + 19
  CALL TextAufbereitung("Goldene Zahl.:" + USING$("_ ##", GZahl%), 76, x%, y%, Modus%)
  RZahl% = (SGRJahr& + 3) MOD 15
  IF RZahl% < 1 THEN RZahl% = RZahl% + 15
  CALL TextAufbereitung("Indiktion....:" + USING$("_ ##", RZahl%) + "<br>", 76, x%, y%, Modus%)

  IF Jahr& > 1582 THEN
    mf% = Festjahr%
    Festjahr% = 3: CALL Kirchenjahr(JD&, Tag%, Monat%, Jahr&, 4, "", Text$, Modus%)
    Festjahr% = mf%
    REPLACE "  " WITH ", " IN Text$
    CALL TextAufbereitung("Gregorianisch: " + Text$, 76, x%, y%, Modus%)
  END IF

  CALL EpakteJul(Jahr&, Epakte%, gz%)
  CALL ZahlRoemisch (Epakte%, ep1$, 1)
  CALL Sonntagsbuchstabe(Jahr&, "EJ", sb$)
  Epakte% = Epakte% - 8: IF Epakte% < 0 THEN Epakte% = Epakte% + 30 'Epakte am 22.3.
  CALL ZahlRoemisch (Epakte%, ep0$, 1)
  Text$ = "Julianisch...: Epakte = " + LCASE$(ep0$) + " (" + LCASE$(ep1$) + " am 1.1.), Sonntagsbuchstabe = " + sb$
  CALL TextAufbereitung(Text$, 76, x%, y%, Modus%)

  IF Jahr& > 0 THEN Regent% = (Jahr& MOD 7) + 21 ELSE Regent% = (ABS(Jahr& + 1) MOD 7) + 21
  CALL LeseDateiName(DN_INFO$, Regent%, a$)
  CALL HistkalLesen(a$, 0, -1, 0, 0, 0, Text$)
  REPLACE "Regent:" WITH "Jahresregent.:" IN Text$
  CALL TextAufbereitung(Text$ + "<br>", 76, x%, y%, Modus%)
  FOR t% = 3 TO 12 STEP 3
    CALL Jahreszeit (JD&, JDE#, AName%, t%)
    CALL JulTageZeit (JDE#, Sekunde%, Minute%, Stunde%, JZ&)
    CALL JulTageGregdatum(JZ&, JTag%, JMonat%, 0)
    CALL LeseMonatsname(Monatsdatei$, JMonat%, Monatsname$, 0)
    Text$ = AstroName$(AName%) + ": " + LTRIM$(STR$(JTag%)) + ". " + Monatsname$ + " um " + RIGHT$(USING$(".##_:", Stunde% / 100), 3) + RIGHT$(USING$(".##_ ", Minute% / 100), 3) + "Uhr"
    IF t% > 3 THEN REPLACE ": " WITH "...: " IN Text$
    CALL TextAufbereitung(Text$, 76, x%, y%, Modus%)
  NEXT t%

  CALL TextAufbereitung("", 76, x%, y%, Modus%)
  OPEN DN_CHRONOLO$ FOR INPUT AS #1
  WHILE NOT EOF(1)
    INPUT #1, a$
    IF RIGHT$(a$, LEN(LJahr$) + 4) = LJahr$ + ".CHR" THEN InfoJahr$ = a$: EXIT LOOP 'Len(LJahr$) fr die Minusjahre die ein Zeichen mehr haben
  WEND
  CLOSE #1
  IF InfoJahr$ <> "" THEN
    OPEN InfoJahr$ FOR INPUT AS #2
    WHILE NOT EOF(2)
      LINE INPUT #2, a$
      CALL TextAufbereitung(a$, 76, x%, y%, Modus%)
    WEND
    CLOSE #2
  END IF
  CALL InfoTextAusgabe(" " + "Das Jahr" + STR$(Jahr&) + " ", x% , y%, 0)
END SUB

SUB TagesChronologie(JD&)
  CALL JultageGregdatum (JD&, Tag%, Nummer%, Jahr&)
  CALL Wochentag (0, 0, 0, JD&, wt%)

  CALL NormaltagNorm (Tag%, Nummer%, a$)
  CALL HoleNamenstag(Tag%, Nummer%, a$, b$): IF b$ <> "" THEN a$ = b$
  IF a$ <> "" THEN CALL TextAufbereitung("Namenstag.......: " + a$, 76, x%, y%, Modus%): Modus% = 1
  CALL Wochentagname(a$, wt%)
  IF a$ <> "" THEN CALL TextAufbereitung("Tagesnamen......: " + a$, 76, x%, y%, Modus%): Modus% = 1
  CALL AstroTagname(a$, wt%)
  IF a$ <> "" THEN CALL TextAufbereitung("Astrologisch....: " + a$, 76, x%, y%, Modus%): Modus% = 1

  mf% = Festjahr%
  Festjahr% = 1: CALL Kirchenjahr(JD&, Tag%, Nummer%, Jahr&, y%, KFText$, Text2$, 2)
  IF KFText$ <> "" THEN CALL TextAufbereitung("Katholisch......: " + KFText$, 76, x%, y%, Modus%): Modus% = 1
  Festjahr% = 2: CALL Kirchenjahr(JD&, Tag%, Nummer%, Jahr&, y%, EFText$, Text2$, 2)
  IF EFText$ <> "" THEN CALL TextAufbereitung("Evangelisch.....: " + EFText$, 76, x%, y%, Modus%): Modus% = 1
  Festjahr% = mf%

  IF FText$ = "" THEN CALL FeiertagOsternG(JD&, Tag%, Nummer%, Jahr&, FText$, "", 0)
  IF FText$ = "" THEN CALL FeiertagOsternG(JD&, Tag%, Nummer%, Jahr&, "", FText$, OFTag&)
  IF FText$ = "" THEN CALL FeiertagAdventG (JD&, Jahr&, FText$, "", 0)
  IF FText$ = "" THEN CALL FeiertagAdventG(JD&, Jahr&, "", FText$, 0)
  IF FText$ = "" THEN CALL FeiertagGreg(JD&, Tag%, Monat%, Jahr&, FText$, "")
  IF FText$ = "" THEN CALL FeiertagGreg(JD&, Tag%, Nummer%, Jahr&, "", FText$)
  IF FText$ = "" THEN CALL WotaImMonat (DN_WOTAGMON$, JD&, Tag%, Nummer%, Jahr&, FText$, 0)
  IF FText$ <> "" AND FText$ <> KFText$ AND FText$ <> EFText$ THEN CALL TextAufbereitung("Allgemein.......: " + FText$, 76, x%, y%, Modus%): Modus% = 1


  CALL RoemischerTag (JD&, "", 0, RoemDatum$, "")
  RoemDatum$ = "Rmischer Tag...: " + RIGHT$(RoemDatum$, LEN(RoemDatum$) - 3)
  CALL TextAufbereitung("<br>" + RoemDatum$, 76, x%, y%, Modus%): Modus% = 1

  CALL JultageScaligerdatum(JD&, SJahr&, Restklasse$)
  a$ = "Julianischer Tag:" + STR$(JD&) + " (ab 12:00 UT)"
  CALL TextAufbereitung(a$, 76, x%, y%, Modus%)

  CALL JulianMond(JD&, JMTag%, 0, 0, 0, 0, 0, 0, "")
  CALL ZahlRoemisch(JMTag%, JMZahl$, 1)
  CALL GregorMond(JD&, GMTag%, 0, 0, 0, 0, 0)
  CALL ZahlRoemisch(GMTag%, GMZahl$, 1)
  MerkeSchiKa&& = SchiKa&&: BIT RESET SchiKa&&, 61 'Finsternis aus
  JD_NM& = JD& + 1
  WHILE AName% <> 1
    JD_NM& = JD_NM& - 1
    CALL Mondphase (JD_NM&, AName%, 0, 0, 0)
  WEND
  SchiKa&& = MerkeSchiKa&&

  a$ = "<br>Luna (Mondalter):<br>"
  a$ = a$ + "julianisch...: " + JMZahl$ + "<br>"
  a$ = a$ + "gregorianisch: " + GMZahl$ + "<br>"
  a$ = a$ + "astronomisch.:" + STR$(JD& - JD_NM&)
  CALL TextAufbereitung(a$, 76, x%, y%, Modus%)

  CALL Indiktion(JD&, Graceae%, Bedana%, Romana%, RomanaA%)
       a$ = "<br>Indiktion:<br> Graceae  (01.09.):" + STR$(Graceae%) + "<br>"
  a$ = a$ + "          Bedana   (24.09.):" + STR$(Bedana%) + "<br>"
  a$ = a$ + "          Romana 1 (25.12.):" + STR$(Romana%) + "<br>"
  a$ = a$ + "          Romana 2 (01.01.):" + STR$(RomanaA%)
  CALL TextAufbereitung(a$, 76, x%, y%, Modus%)

  CALL JultageJuldatum(JD&, JTag%, JMonat%, JJahr&)
  CALL LeseMonatsname("STANDARD.MON", JMonat%, Julianname$, 0)
  FTJul$ = "": CALL FeiertagOsternJ (JD&, JTag%, JMonat%, JJahr&, FTJul$)
  IF FTJul$ = "" THEN CALL FeiertagOrth (JTag%, JMonat%, FTJul$)
  IF FTJul$ = "" THEN CALL FeiertagAdventJ (JD&, JJahr&, FTJul$, Diff&)
  a$ = "<br>Julianisch: " + USING$("##_._ ", JTag%) + Julianname$ + STR$(JJahr&)
  IF FTJul$ <> "" THEN a$ = a$ + ", "+ FTJul$
  CALL TextAufbereitung(a$, 76, x%, y%, Modus%)

  CALL JultageKoptdatum (JD&, KTag%, KMonat%, KJahr&)
  CALL LeseMonatsname("KOPTISCH.MON", KMonat% + 1, Koptname$, 0)
  a$ = "Koptisch..: " + USING$("##_._ ", KTag%) + Koptname$ + STR$(KJahr&)
  FtKop$ = "": CALL FeiertagOsternK (JD&, JTag%, JMonat%, JJahr&, FTKop$)
  IF FTKop$ = ""  THEN CALL FeiertagKopt (KTag%, KMonat%, FTKop$)
  IF FTKop$ <> "" THEN a$ = a$ + ", " + FTKop$
  CALL TextAufbereitung(a$, 76, x%, y%, Modus%)

  CALL JultageJuddatum(JD&, JuTag%, JuMonat%, JuJahr&, JL%)
  CALL LeseMonatsname("JUEDISCH.MON", JuMonat%, Juedname$, 0)
  a$ = "Jdisch...: " + USING$("##_._ ", JuTag%) + Juedname$ + STR$(JuJahr&)
  CALL FeiertagJued (JuTag%, JuMonat%, wt%, JL%, FTJud$)
  IF FTJud$ <> "" THEN a$ = a$ + ", " + FTJud$
  CALL TextAufbereitung(a$, 76, x%, y%, Modus%)

  CALL JultageMoham (JD&, MTag%, MMonat%, MJahr&)
  CALL LeseMonatsname("ISLAM.MON", MMonat%, Mohamname$, 0)
  FTMoham$ = "": CALL FeiertagIslam (MTag%, MMonat%, FTMoham$)
  a$ = "Islamisch.: " + USING$("##_._ ", MTag%) + Mohamname$ + STR$(MJahr&)
  IF FTMoham$ <> "" THEN a$ = a$ + ", " + FTMoham$
  CALL TextAufbereitung(a$, 76, x%, y%, Modus%)

  CALL JultageKhayam (JD&, KhTag%, KhMonat%, KhJahr&)
  CALL LeseMonatsname("PERSISCH.MON", KhMonat%, Khayamname$, 0)
  a$ = "Persisch..: " + USING$("##_._ ", KhTag%) + Khayamname$ + STR$(KhJahr&)
  CALL TextAufbereitung(a$, 76, x%, y%, Modus%)

  CALL AufUntergang (1, JD&, Tag%, Nummer%, Jahr&, Auf$, Unter$)
  CALL TextAufbereitung("", 76, x%, y%, Modus%): Modus% = 1
  CALL Sommerzeit (Tag%, Nummer%, Jahr&, Anfang%, Ende%)
  IF Nummer% * 100 + Tag% > Anfang% AND Nummer% * 100 + Tag% <= Ende% THEN sz% = 1: a$ = "(Sommerzeit)" ELSE a$ = "": sz% = 0  'Sommerzeit
  IF KZone < 0 THEN b$ = "UT -" + STR$(ABS(KZone + sz%)) ELSE b$ = "UT +" + STR$(KZone + sz%)

  CALL TextAufbereitung(KName$, 76, x%, y%, Modus%): Modus% = 1
  CALL TextAufbereitung("Lnge: " + LTRIM$(USING$("###.##", KLaenge)) + ", Breite: " + LTRIM$(USING$("##.##", KBreite)) + ", Zeitzone: " + b$ + " Std., " + a$, 76, x%, y%, Modus%): Modus% = 1
  IF Auf$ > Unter$ THEN
    Unter$ = Unter$ + ", "
    CALL TextAufbereitung("Monduntergang...: " + Unter$ + "Mondaufgang.....: " + Auf$, 76, x%, y%, Modus%): Modus% = 1
  ELSE
    Auf$ = TRIM$(Auf$) + ", "
    CALL TextAufbereitung("Mondaufgang.....: " + Auf$ + "Monduntergang...: " + Unter$, 76, x%, y%, Modus%): Modus% = 1
  END IF
  CALL AufUntergang (2, JD&, Tag%, Nummer%, Jahr&, Auf$, Unter$)
  CALL TextAufbereitung("Sonnenaufgang...: " + TRIM$(Auf$) + ", " + "Sonnenuntergang.: " + Unter$, 76, x%, y%, Modus%): Modus% = 1
  CALL AufUntergang (3, JD&, Tag%, Nummer%, Jahr&, Auf$, Unter$)
  CALL TextAufbereitung("Dmmerungsbeginn: " + TRIM$(Auf$) + ", " + "Dmmerungsende..: " + Unter$ + ", brgerlich", 76, x%, y%, Modus%): Modus% = 1
  CALL AufUntergang (4, JD&, Tag%, Nummer%, Jahr&, Auf$, Unter$)
  CALL TextAufbereitung("Dmmerungsbeginn: " + TRIM$(Auf$) + ", " + "Dmmerungsende..: " + Unter$ + ", nautisch", 76, x%, y%, Modus%): Modus% = 1

  CALL Mondphase (JD&, AName%, Sekunde%, Minute%, Stunde%)
  IF AName% THEN
    Text$ = AstroName$(AName%) + RIGHT$("................: ", 18 - LEN(AstroName$(AName%))) + RIGHT$(USING$(".##_:", Stunde% / 100), 3) + RIGHT$(USING$(".##_ ", Minute% / 100), 3)
    CALL TextAufbereitung(Text$, 76, x%, y%, Modus%): Modus% = 1
  END IF
  CALL Jahreszeit (JD&, JDE#, AName%, 0)
  CALL JulTageZeit (JDE#, Sekunde%, Minute%, Stunde%, JZ&)
  IF JD& = JZ& AND AName% THEN
    Text$ = AstroName$(AName%) + RIGHT$("................: ", 18 - LEN(AstroName$(AName%))) + RIGHT$(USING$(".##_:", Stunde% / 100), 3) + RIGHT$(USING$(".##_ ", Minute% / 100), 3)
    CALL TextAufbereitung(Text$, 76, x%, y%, Modus%)
    Modus% = 1
  END IF

  CALL TextAufbereitung("", 76, x%, y%, Modus%): Modus% = 1
  CALL TextAufbereitung("Spruch des Tages:", 76, x%, y%, Modus%)
  CALL LeseSpruch(JD&, Text$)
  CALL TextAufbereitung(Text$, 76, x%, y%, Modus%)

  CALL TextAufbereitung("", 76, x%, y%, Modus%): Modus% = 1
  CALL TextAufbereitung("Speiseplan:", 76, x%, y%, Modus%)
  CALL LeseSpeiseplan(JD&, Nummer%, Text$)
  CALL TextAufbereitung(Text$, 76, x%, y%, Modus%)

  CALL TextAufbereitung("", 76, x%, y%, Modus%): Modus% = 1
  CALL LeseMonatsname("STANDARD.MON", Nummer%, Monat$, 0)
  Datum$ = LTRIM$(STR$(Tag%)) + ". " + Monat$

  OPEN DN_CHRONOLO$ FOR INPUT AS #2
  WHILE NOT EOF(2)
    INPUT #2, InfoJahr$
    OPEN InfoJahr$ FOR INPUT AS #3
    WHILE NOT EOF(3)
      LINE INPUT #3, a$
      IF Datum$ = a$ THEN
        CALL TextAufbereitung(LEFT$(RIGHT$(InfoJahr$, 8), 4), 76, x%, y%, Modus%) 'Das Jahr ausgeben
        WHILE a$ <> "" AND NOT EOF(3) 'Text bis zum nchsten Absatz holen
          LINE INPUT #3, a$
          IF a$ <> "" THEN CALL TextAufbereitung(a$, 76, x%, y%, Modus%)
        WEND
        EXIT LOOP
      END IF
    WEND
    CLOSE #3
  WEND
  CLOSE #2

  IF Modus% THEN CALL InfoTextAusgabe(" " + Tagesname$(wt%) + ", " + Datum$ + STR$(Jahr&) + " ", x% , y%, 0)
END SUB

SUB NormaltagNorm (Tag%, Monat%, NTName$)
 'Holt einen Namenstag in NTName$
 CALL HoleNamenstag(Tag%, Monat%, NTName$, "")
 'CALL RandomLesen (DN_NAMENTAG$, Monat% * 100 + Tag%, NTName$, z1&, z2&, Ort%, Ende%, Stelle%, JDN&, c$)
END SUB

SUB HoleNamenstag(Tag%, Monat%, Kurz$, Lang$)
 OPEN DN_NAMENTAG$ FOR INPUT AS #1
 WHILE NOT EOF(1) AND Test% = 0
   INPUT #1, Datum&, Kurz$, Lang$, a&, b&
   IF Monat% * 100 + Tag% = Datum& THEN Test% = 1
 WEND
 IF Test% = 0 THEN Kurz$ = "": Lang$ = ""
 CLOSE #1
END SUB

SUB SchreibeNamenstag(Tag%, Monat%, Kurz$, Lang$)
 NameTemp$ = LEFT$(DN_NAMENTAG$, LEN(DN_NAMENTAG$) - 3) + "TPM"
 OPEN DN_NAMENTAG$ FOR INPUT AS #1
 OPEN NameTemp$ FOR OUTPUT AS #2
 WHILE NOT EOF(1) AND Test% = 0
   INPUT #1, Datum%, NKurz$, NLang$, a&, b&
   IF Monat% * 100 + Tag% = Datum% THEN NKurz$ = Kurz$: NLang$ = Lang$
   WRITE #2, Datum%, NKurz$, NLang$, a&, b&
 WEND
 CLOSE #1, #2
 KILL DN_NAMENTAG$
 NAME NameTemp$ AS DN_NAMENTAG$
END SUB

SUB SucheNamenstag(Suche$, Stelle%, Gefunden$)
 OPEN DN_NAMENTAG$ FOR INPUT AS #1
 WHILE NOT EOF(1) AND Test% = 0
   INPUT #1, Datum%, Kurz$, Lang$, a&, b&
   IF Stelle% < Datum% THEN
     Monat% = INT(Datum% / 100): Tag% = Datum% - Monat% * 100
     IF INSTR(UCASE$(Kurz$), UCASE$(Suche$)) THEN Gefunden$ = LTRIM$(STR$(Tag%)) + "." + LTRIM$(STR$(Monat%)) + ". " + Kurz$: Test% = 1
     IF INSTR(UCASE$(Lang$), UCASE$(Suche$)) THEN Gefunden$ = LTRIM$(STR$(Tag%)) + "." + LTRIM$(STR$(Monat%)) + ". " + Lang$: Test% = 1
   END IF
 WEND
 IF Test% = 1 THEN Stelle% = Datum%
 CLOSE #1
END SUB

SUB NamenstagEingabe (JD&, Test%)
 diainputsize% = %NamTagLaenge 'sichbare Eingabelnge
 Test% = 0

 CALL JultageGregdatum (JD&, Tag%, Monat%, Jahr&)
 CALL LeseMonatsname(DN_STANDARD$, Monat%, Monatsname$, 0)
 IF LEN(Monatsname$) > 19 THEN Monatsname$ = LEFT$(Monatsname$, 19)
 Datum$ = LTRIM$(STR$(Tag%)) + ". " + Monatsname$
 'NamTag& = Monat% * 100 + Tag%
 CALL HoleNamenstag(Tag%, Monat%, TextK$, TextL$)
 'CALL RandomLesen (DN_NAMENTAG$, NamTag&, Text$, z1&, z2&, Ort%, Ende%, a%, b&, c$)

 CALL diawin (2, Spalte%, 11, 43, " Eingabe eines Namenstages ", %ON)
 CALL diaprint (2, 2, "Datum.........: " + Datum$)
 CALL diainp (4, 2, "Namenstag kurz:", 4, 18, %NamTagLaenge, TextK$)
 CALL diainp (6, 2, "Namenstag lang:", 6, 18, 235, TextL$)
 CALL diapush (8, 28, "bernehmen")
 CALL diapush (8, 2, "Abbruch")
 CALL diaset (1)
 DO
   d% = dialog%
   l% = lastkeyx%
   IF l% = %ESC OR d% = 4 THEN Test% = 0 : CALL diaclose : mouseon : EXIT SUB
   IF (d% = 2 OR d% = 3) AND l% = %ENTER THEN
     IF TextK$ = "" THEN CALL Fehlermeldung ("77") ELSE EXIT LOOP
   END IF
 LOOP
 CALL diaclose : mouseon
 CALL SchreibeNamenstag(Tag%, Monat%, TextK$, TextL$)
 'CALL RandomEinfuegen (DN_NAMENTAG$, NamTag&, Text$, z1&, z2&)
 Test% = 1
END SUB

'SUB Suche_nach_Namestag(Suche$, Stelle%, Anfang&, Gefunden$)
'  OPEN DN_NAMENTAG$ FOR RANDOM AS #1 LEN = %NamTagLaenge + 12: FIELD #1, 4 AS NamDatum$, %NamTagLaenge AS NamText$, 4 AS DAT1$, 4 AS DAT2$
''  'Zum letzten Eintrag
'  WHILE NOT EOF(1) AND t% < Stelle%
'    t% = t% + 1
'    GET #1, t%
'  WEND
'  'Suche den Namen
'  Gefunden$ = "": Stelle% = 0
'  WHILE NOT EOF(1)
'    t% = t% + 1
'    GET #1, t%
'    IF INSTR(LCASE$(NamText$), LCASE$(Suche$)) THEN
'      TDatum& = CVL(NamDatum$): Monat% = INT(TDatum& / 100): Tag% = TDatum& - Monat% * 100
'      Gefunden$ = LTRIM$(STR$(Tag%)) + "." + LTRIM$(STR$(Monat%)) + ". " + NamText$
'      Stelle% = t%
'      EXIT LOOP
'    END IF
'  WEND
'  CLOSE #1
'END SUB

SUB AufbereitungHerrscher(Text$)
  WHILE INSTR(Text$, "<br><br>")
    REPLACE "<br><br>" WITH "<br>" IN Text$
  WEND
  REPLACE "<br>" WITH ", " IN Text$
  REPLACE ",," WITH "," IN Text$
  REPLACE "  " WITH " " IN Text$
  REPLACE "#" WITH "" IN Text$
END SUB

SUB Suche_nach_Sanktorale(Pfadname$, Suche$, Stelle%, Anfang&, Gefunden$)
  OPEN Pfadname$ FOR INPUT AS #1
  'Zum letzten Eintrag
  WHILE NOT EOF(1) AND t% < Stelle%
    t% = t% + 1
    LINE INPUT #1, a$
  WEND
  'Suche den Namen
  Gefunden$ = "": Stelle% = 0
  WHILE NOT EOF(1)
    t% = t% + 1
    LINE INPUT #1, a$
    IF INSTR(LCASE$(a$), LCASE$(Suche$)) AND VAL(LEFT$(a$, 4)) > 101 THEN
      CALL AufbereitungHerrscher(a$)
      Gefunden$ = MID$(a$, 3 ,2) + "." + LEFT$(a$, 2) + ". " + RIGHT$(a$, LEN(a$) - 4)
      Stelle% = t%
      EXIT LOOP
    END IF
  WEND
  CLOSE #1
END SUB

SUB Suche_nach_Herrscher(Pfadname$, Suche$, Stelle%, Anfang&, RegZeit$, Gefunden$)
  OPEN Pfadname$ FOR INPUT AS #1
  'Zum letzten Eintrag
  WHILE NOT EOF(1) AND t% < Stelle%
    t% = t% + 1
    INPUT #1, Anfang&, Ende&, Gefunden$
  WEND
  'Suche den Namen
  Gefunden$ = "": Stelle% = 0
  WHILE NOT EOF(1)
    t% = t% + 1
    INPUT #1, Anfang&, Ende&, Gefunden$
    IF INSTR(LCASE$(Gefunden$), LCASE$(Suche$)) THEN
      CALL AufbereitungHerrscher(Gefunden$)
      CALL DatumZahl_nach_JD(Anfang&, 0, ATag%, AMonat%, AJahr&)
      CALL DatumZahl_nach_JD(Ende&, 0, ETag%, EMonat%, EJahr&)
      RegZeit$ = LTRIM$(STR$(ATag%)) + "." + LTRIM$(STR$(AMonat%)) + "." + LTRIM$(STR$(AJahr&)) + " bis "
      RegZeit$ = RegZeit$ + LTRIM$(STR$(ETag%)) + "." + LTRIM$(STR$(EMonat%)) + "." + LTRIM$(STR$(EJahr&))
      Stelle% = t%
      EXIT LOOP
    ELSE
      Gefunden$ = ""
    END IF
  WEND
  CLOSE #1
END SUB

SUB SanktoraleTag(JD&, Tag%, Monat%, Jahr&)
  'OPEN DN_SANKTORA$ FOR BINARY AS #2: CLOSE #2
  OPEN DN_SANKTORA$ FOR INPUT AS #2
  WHILE NOT EOF(2)
    INPUT #2, Pfadname$
    a$ = "": 'Pfadname$ = "SANKTORA\" + Pfadname$ + ".KAL"
    CALL HoleSanktoraleDateiTitel(Pfadname$, Titel$)
    CALL HistkalLesen(Pfadname$, JD&, Tag%, Monat%, Jahr&, 0, a$)
    IF a$ <> "" THEN
      Sankto$ = Titel$ + ": " + a$ + "<br>"
      CALL TextAufbereitung(Sankto$, 76, x%, y%, Modus%)
      IF NOT Modus% THEN Modus% = 1
    END IF
  WEND
  CLOSE #2
  CALL LeseMonatsname(Monatsdatei$, Monat%, Monatsname$, 0)
  Text$ = LTRIM$(STR$(Tag%))+ ". " + Monatsname$
  CALL InfoTextAusgabe(" " + Text$ + " ", x% , y%, 0)
END SUB

SUB HoleHerrscherDateiTitel(Pfadname$, Titel$)
  'OPEN Pfadname$ FOR BINARY AS #1: Test% = LOF(1): CLOSE #1: IF Test% = 0 THEN EXIT SUB
  OPEN Pfadname$ FOR INPUT AS #1
  INPUT #1, Anfang&, Ende&, a$
  IF Anfang& = 0 AND Ende& = 0 THEN Titel$ = a$ ELSE Titel$ = Pfadname$
  CLOSE #1
END SUB

SUB HoleSanktoraleDateiTitel(Pfadname$, Titel$)
  'OPEN Pfadname$ FOR BINARY AS #1: Test% = LOF(1): CLOSE #1: IF Test% = 0 THEN EXIT SUB
  OPEN Pfadname$ FOR INPUT AS #1
  LINE INPUT #1, a$
  IF LEFT$(a$, 4) = "0000" THEN Titel$ = RIGHT$(a$, LEN(a$) - 4) ELSE Titel$ = Pfadname$
  CLOSE #1
END SUB

SUB HoleDateiListe(DNummer%, Datei$, Liste$)
  OPEN Liste$ FOR INPUT AS #1
  WHILE NOT EOF(1)
    t% = t% + 1
    INPUT #1, a$
    IF t% > DNummer% THEN Datei$ = a$: DNummer% = t%: EXIT LOOP
  WEND
  IF EOF(1) THEN DNummer% = 0
  CLOSE #1
END SUB

SUB DurchsucheHerrscher(Suche$, Datei$, Stelle%, DNummer%, Anfang&, RegZeit$, Gefunden$)
  'Suchen der nchsten bereinstimmung
  Gefunden$ = ""
  WHILE Gefunden$ = ""
    IF Stelle% = 0 THEN CALL HoleDateiListe(DNummer%, Datei$, DN_HERRSCHE$)
    CALL Suche_nach_Herrscher(Datei$, Suche$, Stelle%, Anfang&, RegZeit$, Gefunden$)
    IF Stelle% = 0 AND DNummer% = 0 THEN EXIT LOOP
  WEND
END SUB

SUB DurchsucheSanktorale(Suche$, Datei$, Stelle%, DNummer%, Anfang&, Gefunden$)
  'Suchen der nchsten bereinstimmung
  Gefunden$ = ""
  WHILE Gefunden$ = ""
    IF Stelle% = 0 THEN CALL HoleDateiListe(DNummer%, Datei$, DN_SANKTORA$)
    CALL Suche_nach_Sanktorale(Datei$, Suche$, Stelle%, Anfang&, Gefunden$)
    IF Stelle% = 0 AND DNummer% = 0 THEN EXIT LOOP
  WEND
END SUB

SUB SucheHerrscherMaske(JD&, Test%, Modus%)
  'Modus% = 1 = Herrscher
  'Modus% = 2 = Sanktorale
  diainputsize% = 38
  dialistmax% = 5
  tmax% = 60
  Test% = 0
  OPEN DN_HERRSCHE$ FOR INPUT AS #1
  WHILE NOT EOF(1)
    hz% = hz% + 1
    LINE INPUT #1, a$
  WEND
  CLOSE #1

  DIM Land$(hz% + 1), HerrscherDatei$(hz%)
  Land$(1) = "Alle Lnder"
  OPEN DN_HERRSCHE$ FOR INPUT AS #1
  FOR t% = 2 TO hz%
    INPUT #1, HerrscherDatei$(t% - 1)
    OPEN HerrscherDatei$(t% - 1) FOR INPUT AS #2
    INPUT #2, b%, c%, Land$(t%)
    CLOSE #2
    IF LEN (Land$(t%)) > m% THEN  m% = LEN(Land$(t%))
  NEXT t%
  CLOSE #1

  IF m% > tmax% THEN m% = tmax%
  CALL diawin (2, Spalte%, 16, 80, " Suche Herrscher ", %ON)
  CALL diainp (2, 2, "Name..........:", 2, 18, 38, Suche$)
  CALL diainp (4, 2, "Regierungsjahr:", 4, 18, 2, RJahr$)
  CALL dialistbox (6, 2, "Land..........:", 6, 18, m%, Land$(1), Auswahl%, %TRUE)


  CALL diapush (13, 2, "Suche")
  CALL diapush (13, 32, "Anzeigen")
  CALL diapush (13, 80 - 9, "Ende")
  CALL diaprint (8, 2, "Liste.........")
  CALL diaprint (10, 2, "Gefunden.....:")
  DO
    d% = dialog
    l% = lastkeyx
    IF d% = 6 AND l% = %ENTER OR l% = %ESC THEN Test% = 0: EXIT LOOP
    IF d% = 1 THEN
      DNummer% = 0: Stelle% = 0: RJahr$ = "1"
    ELSEIF d% = 3 THEN
      DNummer% = 0: Stelle% = 0: IF Auswahl% > 1 THEN  Datei$ = HerrscherDatei$(Auswahl% - 1)
    ELSEIF d% = 4 AND l% = %ENTER AND Suche$ <> "" THEN
      CALL diaprint (8, 18, SPACE$(tmax%))
      CALL diaprint (10, 18, SPACE$(tmax%))
      CALL diaprint (11, 18, SPACE$(tmax%))
      IF Auswahl% = 1 THEN
        CALL DurchsucheHerrscher(Suche$, Datei$, Stelle%, DNummer%, Anfang&, RegZeit$, Gefunden$)
      ELSE
        CALL Suche_nach_Herrscher(Datei$, Suche$, Stelle%, Anfang&, RegZeit$, Gefunden$)
      END IF
      IF Gefunden$ <> "" THEN
        IF LEN(Gefunden$) > tmax% THEN Gefunden$ = LEFT$(Gefunden$, tmax%)
        IF Modus% = 1 THEN CALL HoleHerrscherDateiTitel(Datei$, Titel$)
        CALL diaprint (8, 18, Titel$)
        CALL diaprint (10, 18, RegZeit$)
        CALL diaprint (11, 18, Gefunden$)
      ELSE
        CALL Fehlermeldung("119")
      END IF
    ELSEIF d% = 5 AND l% = %ENTER AND Gefunden$ <> "" THEN
      CALL DatumZahl_nach_JD(Anfang&, JD&, 0, 0, 0): Herrkal$ = Datei$
      IF VAL(RJahr$) - 1 > 0 THEN Anfang& = Anfang& + ((VAL(RJahr$) - 1) * 10000)
      CALL DatumZahl_nach_JD(Anfang&, JD&, 0, 0, 0)
      Test% = 1
      EXIT LOOP
    END IF
  LOOP
  CALL diaclose: mouseon
  ERASE HerrscherDatei$, Land$
END SUB

SUB SucheEingabeMaske(JD&, Test%, Modus%)
  'Modus% = 1 = Herrscher
  'Modus% = 2 = Sanktorale
  'Modus% = 3 = Namenstag
  diainputsize% = 38
  tmax% = 61
  Test% = 0
  IF Modus% = 2 THEN a$ = " Suche Sanktorale "
  IF Modus% = 3 THEN a$ = " Suche Namenstag "

  CALL diawin (2, Spalte%, 11, 76, a$, %ON)
  CALL diainp (2, 2, "Suchtext.:", 2, 13, 38, Suche$)
  CALL diapush (8, 2, "Suche")
  CALL diapush (8, 32, "Anzeigen")
  CALL diapush (8, 76 - 9, "Ende")
  CALL diaprint (4, 2, "Datei...:")
  CALL diaprint (6, 2, "Gefunden:")
  DO
    d% = dialog
    l% = lastkeyx
    IF d% = 4 AND l% = %ENTER OR l% = %ESC THEN Test% = 0: EXIT LOOP
    IF d% = 1 THEN
      DNummer% = 0: Stelle% = 0
    ELSEIF d% = 2 AND l% = %ENTER AND Suche$ <> "" THEN
      CALL diaprint (4, 13, SPACE$(tmax%))
      CALL diaprint (6, 13, SPACE$(tmax%))
      IF Modus% = 2 THEN CALL DurchsucheSanktorale(Suche$, Datei$, Stelle%, DNummer%, Anfang&, Gefunden$)
      IF Modus% = 3 THEN CALL SucheNamenstag(Suche$, Stelle%, Gefunden$) 'CALL Suche_nach_Namestag(Suche$, Stelle%, Anfang&, Gefunden$)
      IF Gefunden$ <> "" THEN
        IF LEN(Gefunden$) > tmax% THEN Gefunden$ = LEFT$(Gefunden$, tmax%)
        IF Modus% = 2 THEN CALL HoleSanktoraleDateiTitel(Datei$, Titel$)
        IF Modus% = 3 THEN Titel$ = "Namenstag"
        CALL diaprint (4, 13, Titel$)
        CALL diaprint (6, 13, Gefunden$)
      ELSE
        CALL Fehlermeldung("119")
      END IF
    ELSEIF d% = 3 AND l% = %ENTER AND Gefunden$ <> "" THEN
      IF Modus% = 1 THEN CALL DatumZahl_nach_JD(Anfang&, JD&, 0, 0, 0): Herrkal$ = Datei$
      IF Modus% = 2 THEN CALL JD_Anzeigen(JD&, Datei$, Gefunden$): Histkal$ = Datei$
      IF Modus% = 3 THEN CALL JD_Anzeigen(JD&, "", Gefunden$)
      Test% = 1
      EXIT LOOP
    END IF
  LOOP
  CALL diaclose: mouseon
END SUB

SUB JD_Anzeigen(JD&, Datei$, Gefunden$)
  IF TALLY(Datei$, "BYZANTIN") OR TALLY(Datei$, "ORTHODOX") THEN
    CALL JultageJuldatum(JD&, 0, 0, Jahr&): Kal$ = "EJ"
  ELSE
    CALL JultageGregdatum(JD&, 0, 0, Jahr&): Kal$ = "Datum"
  END IF
  Tag% = VAL(LEFT$(Gefunden$, INSTR(Gefunden$, ".") - 1))
  Monat% = VAL(MID$(Gefunden$, INSTR(Gefunden$, ".") + 1, 2))
  CALL DatumEingabeUmrechnen(Tag%, Monat%, Jahr&, Kal$, JD&, 0)
END SUB

SUB Kalenderinfo
 IF Infodatei$ = "" THEN EXIT SUB
 OPEN Infodatei$ FOR INPUT AS #2
 LINE INPUT #2, Text$ 'erste Zeile als beschrift
 WHILE NOT EOF(2)
   LINE INPUT #2, a$
   CALL TextAufbereitung(a$, 76, x%, y%, Modus%)
   IF NOT Modus% THEN Modus% = 1
 WEND
 CLOSE #2
 CALL InfoTextAusgabe(" " + Text$ + " ", x% , y%, 0)
END SUB

SUB SucheLexikonBegriff(JD&, Suche$, Ergebnis$, Stelle%)
   LexiName$ = DN_LEXIKON$
   CALL JultageGregdatum (JD&, Tag%, Monat%, Jahr&)
   'Kirchenjahr und Feiertage
   CALL FeiertagOsternG(JD&, Tag%, Monat%, Jahr&, Suche$, a$, 0): IF Suche$ = "" THEN Suche$ = a$
   IF Suche$ = "" THEN CALL WotaImMonat(DN_WOTAGMON$, JD&, Tag%, Monat%, Jahr&, Suche$, 0)
   IF Suche$ = "" THEN CALL FeiertagAdventG(JD&, Jahr&, Suche$, a$, 0): IF Suche$ = "" THEN Suche$ = a$
   IF Suche$ = "" THEN CALL FeiertagGreg(JD&, Tag%, Monat%, Jahr&, Suche$, a$): IF Suche$ = "" THEN Suche$ = a$
   IF Suche$ <> "" THEN CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 0)
   'Jdisch
   IF Ergebnis$ = "" THEN
     CALL JultageJuddatum (JD&, JuTag%, JuMonat%, JuJahr&, JL%)
     CALL FeiertagJued (JuTag%, JuMonat%, wt%, JL%, Suche$)
     IF Suche$ <> "" THEN CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 0)
   END IF
   mfj% = Festjahr%
   'Katholisches Kirchenjahr
   IF Ergebnis$ = "" THEN
     FestJahr% = 1: CALL Kirchenjahr(JD&, Tag%, Monat%, Jahr&, 0, Suche$, "", 0)
     IF Suche$ <> "" THEN CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 0)
   END IF
   'Evangelisches Kirchenjahr
   IF Ergebnis$ = "" THEN
     FestJahr% = 2: CALL Kirchenjahr(JD&, Tag%, Monat%, Jahr&, 0, Suche$, "", 0)
     IF Suche$ <> "" THEN CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 0)
   END IF
   'Islamisch
   IF Ergebnis$ = "" THEN
     CALL JultageMoham (JD&, MTag%, MMonat%, MJahr&)
     CALL FeiertagIslam (MTag%, MMonat%, Suche$)
     IF Suche$ <> "" THEN CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 0)
   END IF
   'UNO
   IF Ergebnis$ = "" THEN
     CALL FeiertagUNO(JD&, Tag%, Monat%, Jahr&, Suche$, 0)
     IF Suche$ <> "" THEN CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 0)
   END IF
   'Namenstag
   IF Ergebnis$ = "" THEN
     CALL NormaltagNorm(Tag%, Monat%, Suche$) 'Namenstag
     IF INSTR(Suche$, ",") THEN Suche$ = LEFT$(Suche$, INSTR(Suche$, ",") - 1)
     IF Suche$ <> "" THEN Stelle% = 1: CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 0)
   END IF
   'Grotefend
   IF Ergebnis$ = "" THEN
     FestJahr% = 5: CALL Kirchenjahr(JD&, Tag%, Monat%, Jahr&, 0, Suche$, "", 0)
     IF Suche$ <> "" THEN CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 0)
   END IF
   Festjahr% = mfj%
   'Datum
   IF Ergebnis$ = "" THEN
     CALL LeseMonatsname(DN_STANDARD$, Monat%, Monatsname$, 0)
     Suche$ = STR$(Tag%) + ". " + LEFT$(Monatsname$, 3)
     IF Suche$ <> "" THEN CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 0)
   END IF
END SUB

SUB BegriffEingabe(JD&, LexiName$)
 diainputsize% = 35
 IF LexiName$ = DN_LEXIKON$ THEN Titel$ = " Lexikon " ELSE Titel$ = " Lateinische Stdtenamen "
 CALL diawin (2, Spalte%, 21, 53, Titel$, %ON)
 CALL diainp (2, 2, "Begriff:", 2, 13, %kommlaenge, Suche$)
 CALL diapush (18, 2, "Suche")
 CALL diapush (18, 13, "Zurck")
 CALL diapush (18, 25, "Vor")
 CALL diapush (18, 34, "Info")
 CALL diapush (18, 44, "Ende")
 IF LexiName$ = DN_LEXIKON$ THEN
   CALL SucheLexikonBegriff(JD&, Suche$, Ergebnis$, Stelle%)
   IF Ergebnis$ <> "" THEN
     CALL TextAufbereitung(Ergebnis$, 50, 0, 0, 0)
     CALL BegriffAusgabe(1, 2, 3, 50, 13, 13)
     CALL diaset(2)
   ELSE
     Suche$ = ""
   END IF
 END IF
 DO
   d% = dialog%
   l% = lastkeyx%

   IF d% = 6 OR l% = %ESC THEN CALL diaclose: mouseon: EXIT SUB

   IF d% = 1 THEN
     Stelle% = 0
   ELSEIF d% = 2 THEN
     CALL TextAufbereitung("", 50, 0, 0, 0)
     CALL BegriffAusgabe(1, 2, 3, 50, 13, 13)
     CALL SucheBegriff(LexiName$, Suche$, Ergebnis$, Stelle%, 1)
   ELSEIF d% = 3 THEN
     Stelle% = Stelle% - 1: IF Stelle% = 0 THEN Stelle% = -1
     CALL SucheBegriff(LexiName$, "", Ergebnis$, Stelle%, 0)
   ELSEIF d% = 4 THEN
     Stelle% = Stelle% + 1
     CALL SucheBegriff(LexiName$, "", Ergebnis$, Stelle%, 0)
   ELSEIF d% = 5 THEN
     CALL LeseDateiName(DN_INFO$, 38, Infodatei$): CALL Kalenderinfo
   END IF

   IF Ergebnis$ <> "" THEN
     CALL TextAufbereitung(Ergebnis$, 50, 0, 0, 0)
     CALL BegriffAusgabe(1, 2, 3, 50, 13, 13)
     Ergebins$ = ""
   END IF
 LOOP
 KILL DN_TEXT_TMP$
END SUB

SUB KommInfoText(JD&)
  CALL JultageGregdatum (JD&, Tag%, Monat%, Jahr&)
  CALL Wochentag (0%, 0%, 0, JD&, wt%)
  CALL KommentarAusgabe(JD&, Jahr&, Monat%, Tag%, wt%, "", "", a$)
  IF a$ = "" THEN EXIT SUB
  CALL LeseMonatsname(Monatsdatei$, Monat%, m$, 0)
  a$ = LTRIM$(STR$(Tag%)) + ". " + m$ + " " + LTRIM$(STR$(Jahr&)) + "<br><br>" + a$
  CALL TextAufbereitung(a$, 76, x%, Zeile%, 0)
  CALL InfoTextAusgabe(" Termine ", x% , Zeile%, 0)
END SUB

SUB InfoTextAusgabe(Text$, Breite%, Zeile%, zstart%)
  'mZeile% = Anzahl der Textzeilen
  'Zeile%  = Anzahl der auszugebenden Zeilen
  'zstart  = Startzeile im Text
  'orz%    = Startzeile des Fensters
  'Spalte% = Startspalte des Fensters
  'y%      = Zeilenzahl des Fensters
  'Breite% = Maximale Textbreite
  'Text$   = berschrift
  'EZeile% = Bildschirmgre (25, 28, 43, 50)
  'sf%     = 1 wenn Zeilenzahl = Ausgabefenster
  'orz%    = 1 wenn Zeilenzahl >= Ausgabefenster, = 2 wenn Zeilenzahl < Ausgabefenster

  mZeile% = Zeile%

  IF Zeile% = EZeile% - 6 THEN sf% = 1
  IF Zeile% >= EZeile% - 6 THEN Zeile% = EZeile% - 6: orz% = 1 ELSE orz% = 2
  y% = 6 + Zeile%
  IF Breite% < LEN(Text$) + 6 THEN Breite% = LEN(Text$) + 6 'berschrift
  IF Breite% < 36 THEN Breite% = 36
  IF zstart% < 1 THEN zstart% = 1

  CALL diawin (orz%, Spalte%, y%, Breite% + 4, Text$, %ON)
  CALL BegriffAusgabe(zstart%, 2, 1, Breite%, Zeile%, mZeile%)

  DO: a$ = INKEY$: LOOP UNTIL a$ = ""

  IF orz% = 2 OR sf% THEN
    CALL diapush (y% - 3, Breite% - 5, " OK ")
    DO
      d% = dialog%
      IF l% = %Esc OR d% = 1 THEN EXIT LOOP
    LOOP
  ELSE
    CALL diapush (y% - 3, 2, "Z" + CHR$(25))
    CALL diapush (y% - 3, 8, "Z" + CHR$(24))
    CALL diapush (y% - 3, Breite% / 2 - 1, "S" + CHR$(25))
    CALL diapush (y% - 3, Breite% / 2 + 5, "S" + CHR$(24))
    CALL diapush (y% - 3, Breite% - 5, " OK ")
    diaset(1)
    DO
      d% = dialog%
      IF d% = 1 THEN a% = 1
      IF d% = 2 THEN a% = 2
      IF d% = 3 THEN a% = 3
      IF d% = 4 THEN a% = 4

      l% = lastkeyx%
      IF l% = %DOWN THEN a% = 1
      IF l% = %UP THEN a% = 2
      IF l% = %PGDN THEN a% = 3
      IF l% = %PGUP THEN a% = 4

      IF a% = 1 THEN zstart% = zstart% + 1
      IF a% = 2 THEN zstart% = zstart% - 1
      IF a% = 3 THEN zstart% = zstart% + y% - 6
      IF a% = 4 THEN zstart% = zstart% - y% + 6
      IF a% THEN CALL BegriffAusgabe(zstart%, 2, 1, Breite%, Zeile%, mZeile%): a% = 0
      IF l% = %Esc OR d% = 5 THEN EXIT LOOP


    LOOP
  END IF
  CALL diaclose: mouseon
$IF %MitEMS
 'nix
$ELSE
  KILL DN_TEXT_TMP$
$ENDIF
END SUB

SUB Herrscherliste(JD&)
 IF Herrkal$ = "" THEN EXIT SUB
 CALL JultageGregdatum (JD&, Tag%, Monat%, Jahr&)
 OPEN Herrkal$ FOR INPUT AS #2
 WHILE NOT EOF(2)
   INPUT #2,Anfang&, Ende&, Herrscher$
   IF Zeile% = 0 AND Anfang& = 0 AND Ende& = 0 THEN
     Titel$ = " " + Herrscher$ + " "
     CALL TextAufbereitung("", 78, x%, y%, 0)
   ELSEIF Anfang& <> 0 THEN
     ATag% = VAL(RIGHT$(STR$(Anfang&),2))
     AMonat% = FIX(VAL(RIGHT$(STR$(Anfang&),4)) / 100)
     AJahr% = FIX(VAL(STR$(Anfang&)) / 10000)
     ETag% = VAL(RIGHT$(STR$(Ende&),2))
     EMonat% = FIX(VAL(RIGHT$(STR$(Ende&),4)) / 100)
     EJahr% = FIX(VAL(STR$(Ende&)) / 10000)
     Text$ = LTRIM$(STR$(ATag%)) + "." + LTRIM$(STR$(AMonat%)) + "." + LTRIM$(STR$(AJahr%)) + " - " + LTRIM$(STR$(ETag%)) + "." + LTRIM$(STR$(EMonat%)) + "." + LTRIM$(STR$(EJahr%)) +  "<br>" + Herrscher$ + "<br>"
     IF AJahr% = Jahr& AND AMonat% = Monat% AND ATag% = Tag% THEN zstart% = y%
     IF AJahr% <= Jahr& THEN zstart2% = y%
     Text$ = REMOVE$(Text$, "99.99.9999")
     CALL TextAufbereitung(Text$, 78, x%, y%, 1)
     IF x% > xm% THEN xm% = x%
   END IF
 WEND
 CLOSE #2
 IF zstart% = 0 THEN zstart% = zstart2%
 CALL InfoTextAusgabe(Titel$, xm% , y%, zstart%)
END SUB

SUB HerrscherText(JD&)
  CALL JultageGregdatum(JD&, Tag%, Monat%, Jahr&)
  CALL LeseMonatsname(Monatsdatei$, Monat%, m$, 0)
  a$ = LTRIM$(STR$(Tag%)) + ". " + m$ + " " + LTRIM$(STR$(Jahr&))
  CALL TextAufbereitung(a$, 76, x%, Zeile%, 0)
  OPEN DN_HERRSCHE$ FOR INPUT AS #2
  WHILE NOT EOF(2)
    INPUT #2, Pfadname$
    CALL LeseHerrscher(Pfadname$, Jahr&, Monat%, Tag%, a$, Titel$)
    IF a$ <> "" THEN
      Test% = 1
      a$ = "<br>" + Titel$ + ":<br>" + a$
      CALL TextAufbereitung(a$, 76, x%, Zeile%, 1)
    END IF
  WEND
  CLOSE #2
  IF Test% = 0 THEN CALL TextAufbereitung("<br>Keine Herrscherdaten fr dieses Datum vorhanden!", 76, x%, Zeile%, 1)
  CALL InfoTextAusgabe(" Herrscher ", x% , Zeile%, zstart%)
END SUB

SUB LeseHerrscher(Pfadname$, Jahr&, Monat%, Tag%, Herrscher$, Titel$)
  IF Pfadname$ = "" THEN EXIT SUB
  Herrscher$ = ""
  TagMonat% = Monat% * 100 + Tag%
  'Zeit& = ABS(Jahr&) * 10000 + Monat% * 100 + Tag%
  'IF Jahr& < 0 THEN Zeit& = Zeit& * -1
  OPEN Pfadname$ FOR INPUT AS #1
  WHILE NOT EOF(1)
    INPUT #1, Anfang&, Ende&, a$
    IF Anfang& = 0 AND Ende& = 0 THEN Titel$ = a$
    IF Anfang& = 0 AND Ende& = 1 THEN KeinJahr% = 1 'Regierungsjahre nicht mitzhlen
    AJahr& = FIX(Anfang& / 10000): ATagMonat% = ABS(Anfang& - AJahr& * 10000)
    EJahr& = FIX(Ende& / 10000): : ETagMonat% = ABS(Ende& - EJahr& * 10000)
    IF (Jahr& > AJahr& AND Jahr& < EJahr&) OR (Jahr& = AJahr& AND  TagMonat% >= ATagMonat%) OR (Jahr& = EJahr& AND TagMonat% <= ETagMonat%) THEN
      IF KeinJahr% = 0 THEN
        Herrscherjahr& = Jahr& - AJahr& + 1
        IF AJahr& < 0 AND Jahr& > 0 THEN Herrscherjahr& = Herrscherjahr& - 1 'Jahr Null
        IF TagMonat% < ATagMonat% THEN Herrscherjahr& = Herrscherjahr& - 1 'Tag des Antrittsdatum noch nicht erreicht
        IF Herrscherjahr& > 0 THEN
          a$ = LTRIM$(STR$(Herrscherjahr&)) + ". " + a$
          IF TagMonat% = ATagMonat% THEN a$ = a$ + "*"
        ELSE
          a$ = "" 'Lschen wenn durch das nicht erreichte Antrittsdatum aus dem 1. das 0. Jahr wird
        END IF
      END IF
      IF Herrscher$ <> "" THEN a$ = "<br>" + a$
      Herrscher$ = Herrscher$ + a$
    END IF
  WEND
  CLOSE #1
END SUB

SUB LeseSpruch(JD&, Spruch$)
  STATIC SpruchZeilen&
  IF SpruchZeilen& = 0 THEN
    OPEN DN_SPRUCH$ FOR INPUT AS #1
    WHILE NOT EOF(1)
      LINE INPUT #1, a$
      SpruchZeilen& = SpruchZeilen& + 1
    WEND
    CLOSE #1
  END IF

  OPEN DN_SPRUCH$ FOR INPUT AS #1
  FOR t& = 1 TO JD& MOD SpruchZeilen& + 1
    LINE INPUT #1, Spruch$
  NEXT t&
  CLOSE #1
END SUB

SUB SanktoText(JD&)
  CALL HistkalLesen (Histkal$, JD&, Tag%, Monat%, Jahr&, Farbe%, a$)
  IF a$ = "" THEN EXIT SUB
  CALL LeseMonatsname(Monatsdatei$, Monat%, m$, 0)
  a$ = LTRIM$(STR$(Tag%)) + ". " + m$ + " " + LTRIM$(STR$(Jahr&)) + "<br><br>" + a$
  CALL TextAufbereitung(a$, 76, x%, Zeile%, 0)
  CALL InfoTextAusgabe(" Langtext ", x% , Zeile%, 0)
END SUB

SUB SanktoInfoText
  CALL HistkalLesen (Histkal$, 0, 1, 0, 0, 0, a$)
  IF a$ = "" THEN a$ = "Keine Beschreibung vorhanden"
  CALL TextAufbereitung(a$, 76, x%, Zeile%, 0)
  CALL InfoTextAusgabe(" Info " , x% , Zeile%, 0)
END SUB

$IF %MitEMS

SUB TextAufbereitung(Text$, xmax%, x%, y%, Modus%)
  'xmax% = Maximale Zeilenbreite
  'x% = Tatschliche maximale Breite
  'y% = Anzahl der Zeilen
  'Modus = 1 hinzfgen, 0 = neu
  'z% = Zeile
  STATIC z%
  a$ = Text$
  IF Modus% = 0 THEN REDIM virtual Ausgabe(5120) AS STRING * 80
  IF Modus% = 0 OR z% = 0 THEN z% = 1
  WHILE 1
    'Umbruch beim <br> wenn es in der max. Zeilenlnge vorkommt
    l% = INSTR(LCASE$(a$), "<br>")
    IF l% AND l% <= xmax% + 1 THEN
      IF l% = 1 THEN Ausgabe$(z%) = "": z% = z% + 1
      IF l% > 1 THEN Ausgabe$(z%) = LTRIM$(LEFT$(a$, l% - 1)): z% = z% + 1
      IF x% < LEN(LTRIM$(LEFT$(a$, l% - 1))) THEN x% = LEN(LTRIM$(LEFT$(a$, l% - 1)))
      IF LEN(a$) >= 4 THEN a$ = RIGHT$(a$, LEN(a$) - 3 - l%)
      y% = y% + 1
    'Das letzte Leerzeichen vor der max. Zeilenlnge suchen und bis dahin ausgeben
    ELSEIF LEN(a$) > xmax% THEN
      y% = y% + 1
      l% = xmax%
      WHILE MID$(a$, l%, 1) <> " " AND l% > 1
        l% = l% - 1
      WEND
      IF l% = 1 THEN l% = xmax% ELSE l% = l% - 1
      Ausgabe$(z%) =  LTRIM$(LEFT$(a$, l%)): z% = z% + 1
      IF x% < LEN(LTRIM$(LEFT$(a$, l%))) THEN x% = LEN(LTRIM$(LEFT$(a$, l%)))
      a$ = RIGHT$(a$, LEN(a$) - l%)
      IF l% = 1 THEN l% = xmax%
    'Die letzte Zeile ausgeben
    ELSEIF LEN(a$) <= xmax% THEN
      IF x% < LEN(LTRIM$(a$)) THEN x% = LEN(LTRIM$(a$))
      y% = y% + 1
      Ausgabe$(z%) =  LTRIM$(a$): z% = z% + 1
      EXIT LOOP
    END IF
  WEND
END SUB

$ELSE

SUB TextAufbereitung(Text$, xmax%, x%, y%, Modus%)
  'xmax% = Maximale Zeilenbreite
  'x% = Tatschliche maximale Breite
  'y% = Anzahl der Zeilen
  'Modus = 1 hinzfgen, 0 = neu
  a$ = Text$
  OPEN DN_TEXT_TMP$ FOR BINARY AS #1: Test& = LOF(1): CLOSE #1
  IF Modus% = 1 AND Test& > 0 THEN
    OPEN DN_TEXT_TMP$ FOR APPEND AS #1
  ELSE
    OPEN DN_TEXT_TMP$ FOR OUTPUT AS #1
  END IF
  WHILE 1
    'Umbruch beim <br> wenn es in der max. Zeilenlnge vorkommt
    l% = INSTR(LCASE$(a$), "<br>")
    IF l% AND l% <= xmax% + 1 THEN
      IF l% = 1 THEN PRINT #1, ""
      IF l% > 1 THEN PRINT #1, LTRIM$(LEFT$(a$, l% - 1))
      IF x% < LEN(LTRIM$(LEFT$(a$, l% - 1))) THEN x% = LEN(LTRIM$(LEFT$(a$, l% - 1)))
      IF LEN(a$) >= 4 THEN a$ = RIGHT$(a$, LEN(a$) - 3 - l%)
      y% = y% + 1
    'Das letzte Leerzeichen vor der max. Zeilenlnge suchen und bis dahin ausgeben
    ELSEIF LEN(a$) > xmax% THEN
      y% = y% + 1
      l% = xmax%
      WHILE MID$(a$, l%, 1) <> " " AND l% > 1
        l% = l% - 1
      WEND
      IF l% = 1 THEN l% = xmax% ELSE l% = l% - 1
      PRINT #1, LTRIM$(LEFT$(a$, l%))
      IF x% < LEN(LTRIM$(LEFT$(a$, l%))) THEN x% = LEN(LTRIM$(LEFT$(a$, l%)))
      a$ = RIGHT$(a$, LEN(a$) - l%)
      IF l% = 1 THEN l% = xmax%
    'Die letzte Zeile ausgeben
    ELSEIF LEN(a$) <= xmax% THEN
      IF x% < LEN(LTRIM$(a$)) THEN x% = LEN(LTRIM$(a$))
      y% = y% + 1
      PRINT #1, LTRIM$(a$)
      EXIT LOOP
    END IF
  WEND
  CLOSE #1
END SUB

$ENDIF

SUB Sonderzeichen(Text$)
  'Sonderzeichen umsetzen
  sa% = INSTR(UCASE$(Text$), "CHR$(")
  IF sa% AND l% <= xmax% + 1 THEN
    se% = INSTR(UCASE$(Text$), ")") + 1
    sz% = VAL(MID$(Text$, sa% + 5, se% - sa%))
    REPLACE MID$(Text$, sa%, se% - sa%) WITH CHR$(sz%) IN Text$
  END IF
END SUB

$IF %MitEMS

SUB BegriffAusgabe(zstart%, xstart%, ystart%, xmax%, ymax%, mz%)
  'zstart% = Startzeile Ausgabetext
  'ystart% = Startzeile Ausgabefenster
  'xstart% = Startspalte Ausgabefenster
  'ymax% = letzte Zeile im Ausgabefenster
  'xmax% = Breite des Ausgabefensters
  'mz% = Gesamtzeilen des Textes

  IF zstart% < 1 THEN zstart% = 1
  IF zstart% > mz% - ymax% + 1 THEN zstart% = mz% - ymax% + 1

  WHILE z% < 5120 AND t% < ymax%
    z% = z% + 1
    b$ = RTRIM$(Ausgabe$(z%))
    CALL Sonderzeichen(b$)
    IF z% >= zstart% THEN
      t% = t% + 1
      IF LEN(b$) > xmax% THEN b$ = "": zstart% = zstart% - 1
      CALL diaprint (t% + ystart%, xstart%, b$ + SPACE$(xmax% - LEN(b$)))
    END IF
  WEND
  'restliche Zeilen mit Leerzeichen berschreiben
  WHILE t% < ymax%
    t% = t% + 1
    CALL diaprint (t% + ystart%, 2, SPACE$(xmax%))
  WEND
  a$ = INKEY$ 'Tastaturpufferberlauf abfangen
END SUB

$ELSE

SUB BegriffAusgabe(zstart%, xstart%, ystart%, xmax%, ymax%, mz%)
  'zstart% = Startzeile Ausgabetext
  'ystart% = Startzeile Ausgabefenster
  'xstart% = Startspalte Ausgabefenster
  'ymax% = Anzahl der Zeilen im Ausgabfenster
  'xmax% = Breite des Ausgabefensters
  'mz% = Gesamtzeilen des Textes

  IF zstart% < 1 THEN zstart% = 1
  IF zstart% > mz% - ymax% + 1 THEN zstart% = mz% - ymax% + 1

  OPEN DN_TEXT_TMP$ FOR INPUT AS #1
  WHILE NOT EOF(1) AND t% < ymax%
    z% = z% + 1
    LINE INPUT #1, b$
    CALL Sonderzeichen(b$)
    IF z% >= zstart% THEN
      t% = t% + 1
      CALL diaprint (t% + ystart%, xstart%, b$ + SPACE$(xmax% - LEN(b$)))
    END IF
  WEND
  CLOSE #1
  'restliche Zeilen mit Leerzeichen berschreiben
  WHILE t% < ymax%
    t% = t% + 1
    CALL diaprint (t% + ystart%, 2, SPACE$(xmax%))
  WEND
END SUB

$ENDIF















                                                              