SUB HTMLTerminKalender(Start&, Ende&)

 CALL StartEndDatum(" HTML-Ausgabe ", Start&, Ende&, Test%)
 IF Test% = 0 THEN EXIT SUB

 IF ABS(Ende& - Start&) > 1000 THEN
   b$ = "Die Datei hat" + STR$(ABS(Ende& - Start&)) + " Zeilen! Soll sie trotzdem erstellt werden?"
   CALL JaNein(b$)
   IF b$ = "N" THEN Test% = 0
 END IF
 IF Test% = 0 THEN EXIT SUB

 IF Start& > Ende& THEN SWAP Start&, Ende&

 CALL fprint(EZeile%,1,SPACE$(%HSpalte*2))
 CALL printf(EZeile%, 1, "Html-Datei erstellen..." + SPACE$(68), attr%)

 'Nachschauen ob Kommentare vorhanden wenn eingeschaltet
 IF (SchiKa&& AND (2 ^62 + 2 ^ 60 + 2 ^ 59 + 2 ^ 51 + 2 ^ 50 + 2 ^ 46 + 2 ^ 33)) = 0 THEN
   FOR t& = Start& TO Ende&
     CALL FormatiereKommentare(t&, Jahr&, Monat%, Tag%, wt%, a$)
     IF a$ <> "&nbsp;" THEN Kommentar% = 1: t& = Ende&
   NEXT t&
 END IF

 OPEN DN_HTML_KAL$ FOR OUTPUT AS #2
 Titel$ = "HTML-Kalender": Beschreibung$ = "Ein vom Programm Unikal erstellter HTML-Kalender"
 CALL HTMLKopftext (Titel$, Beschreibung$)
 PRINT #2,"<table align=" + CHR$(34) + "center" + CHR$(34) + " border=" + CHR$(34) + "1" + CHR$(34) + ">"
 FOR t& = Start& TO Ende&
   PRINT #2,"<TR>"

   CALL JultageGregdatum (t&, Tag%, Monat%, Jahr&)
   CALL Wochentag (Tag%, Monat%, Jahr&, t&, wt%)
   CALL HTMLFeiertage(t&, Tag%, Monat%, Jahr&, wt%, FText$, rot%)

   CALL LeseKalendermarkierung(t&, Modus%)
   IF Modus% = 1 THEN HFarbe$ = "#F0F0F0" ELSE HFarbe$ = "#FFFFFF"

   IF wt% = 7 OR rot% = 1 THEN
     Farbe$ = "#ff0000"
   ELSEIF wt% = 6 THEN
     Farbe$ = "#00a000"
   ELSE
     Farbe$ = "#000000"
   END IF

   'Tagesname
   a$ = LEFT$(Tagesname$(wt%),2)
   PRINT #2,"<td bgcolor=" + CHR$(34) + HFarbe$ + CHR$(34)"><span style=" + CHR$(34) + "color:" + Farbe$ + CHR$(34) +">" + a$ + "</span></td>"

   'Datum (Tag.Monat)
   a$ = LTRIM$(STR$(Tag%)) + "." + LTRIM$(STR$(Monat%)) + "." + LTRIM$(STR$(Jahr&))
   PRINT #2,"<td align=" + CHR$(34) + "right" + CHR$(34) + "><span style=" + CHR$(34) + "color:" + Farbe$ + CHR$(34) +">" + a$ + "</span></td>"

   'Feiertage
   IF FText$ <> "" THEN
     IF Farbe$ = "#00a000" THEN Farbe$ = "#000000"
     PRINT #2,"<td><span style=" + CHR$(34) + "COLOR:" + Farbe$ + CHR$(34) +">" + FText$ + "</span></td>"
   END IF

   'Kommentare
   IF Kommentar% THEN
     Farbe$ = "#000000"
     CALL FormatiereKommentare(t&, Jahr&, Monat%, Tag%, wt%, a$)
     CALL Umlaute_nach_HTML(a$)
     PRINT #2,"<td><span style=" + "color:" + CHR$(34) + Farbe$ + CHR$(34) +">" + a$ + "</span></td>"
   END IF

   PRINT #2,"</TR>
 NEXT t&
 PRINT #2,"</table>"
 PRINT #2,"</body>"
 PRINT #2,"</html>"
 CLOSE #2
 CALL fprint(EZeile%,1,SPACE$(%HSpalte*2))
 CALL Fehlermeldung("Die Datei '" + CURDIR$ + "\" + DN_User$ + "HTML-Kal.htm' wurde erstellt")
END SUB

SUB FormatiereKommentare(t&, Jahr&, Monat%, Tag%, wt%, a$)
 CALL RandomLesen (DN_SCHIKALA$, t&, Absolut$, z1&, z2&, Ort%, Ende%, a%, b&, c$)
 CALL LesePeriodeTag(t&, Periodisch$, 0, 0)
 CALL LesePeriodeWoche(t&, Periodisch$, 0, 0)
 CALL LesePeriodeMonat(t&, Jahr&, Monat%, Tag%, Periodisch$, 0, 0)
 CALL LesePeriodeJahr(t&, Jahr&, Monat%, Tag%, Periodisch$, 0, 0, 0)

 CALL Schaltjahr (Tag%, Monat%, Jahr&)
 CALL Wochentag (1, Monat%, Jahr&, 0, wt1%)
 pNummer% = ABS(INT((- Tag% - wt1% + 1) / 7))
 IF wt% < wt1% THEN pNummer% = pNummer% -1

 CALL RandomLesen (DN_SCHIKALW$, pNummer% * 1000 + wt% * 100 + Monat%, WotaMonat1$, z1&, z2&, Ort%, Ende%, a%, b&, c$)
 CALL RandomLesen (DN_SCHIKALW$, pNummer% * 1000 + wt% * 100 + 13, WotaMonat2$, z1&, z2&, Ort%, Ende%, a%, b&, c$)

 pNummer% = 10 - pNummer%
 FOR t% = Monatstage%(Monat%) TO 29 STEP -1
   CALL Wochentag (t%, Monat%, Jahr&, 0, wt1%)
   IF wt% = wt1% THEN pNummer% = pNummer% +1 : t% = 29
 NEXT t%

 CALL RandomLesen (DN_SCHIKALW$, pNummer% * 1000 + wt% * 100 + Monat%, WotaMonat3$, z1&, z2&, Ort%, Ende%, a%, b&, c$)
 CALL RandomLesen (DN_SCHIKALW$, pNummer% * 1000 + wt% * 100 + 13, WotaMonat4$, z1&, z2&, Ort%, Ende%, a%, b&, c$)

 a$ = Absolut$
 IF Periodisch$ <> "" THEN
   IF a$ ="" THEN a$ = Periodisch$ ELSE a$ = a$ + "<BR>" + Periodisch$
 END IF
 IF WotaMonat1$ <> "" THEN
   IF a$ ="" THEN a$ = WotaMonat1$ ELSE a$ = a$ + "<BR>" + WotaMonat1$
 END IF
 IF WotaMonat2$ <> "" THEN
   IF a$ ="" THEN a$ = WotaMonat2$ ELSE a$ = a$ + "<BR>" + WotaMonat2$
 END IF
 IF WotaMonat3$ <> "" THEN
   IF a$ ="" THEN a$ = WotaMonat3$ ELSE a$ = a$ + "<BR>" + WotaMonat3$
 END IF
 IF WotaMonat4$ <> "" THEN
   IF a$ ="" THEN a$ = WotaMonat4$ ELSE a$ = a$ + "<BR>" + WotaMonat4$
 END IF
 IF a$ = "" THEN a$ = "&nbsp;"
END SUB

SUB Umlaute_nach_HTML(a$)
 REPLACE " | " WITH "<BR>" IN a$
 REPLACE " " WITH "&nbsp;" IN a$
 REPLACE "" WITH "&Auml;" IN a$
 REPLACE "" WITH "&Ouml;" IN a$
 REPLACE "" WITH "&Uuml;" IN a$
 REPLACE "" WITH "&auml;" IN a$
 REPLACE "" WITH "&ouml;" IN a$
 REPLACE "" WITH "&uuml;" IN a$
 REPLACE "" WITH "&szlig;" IN a$
 REPLACE "" WITH "&aacute;" IN a$
END SUB

SUB HTMLKopftext (Titel$, Beschreibung$)
   PRINT #2,"<!DOCTYPE HTML PUBLIC " + CHR$(34) + "-//W3C//Dtd HTML 4.01 Transitional//EN" + CHR$(34) +">"
   PRINT #2,"<html>"
   PRINT #2,"<head>"
   PRINT #2,"<title>" + Titel$ + "</title>"
   PRINT #2,"<meta HTTP-EQUIV=" + CHR$(34) + "Content-TYPE" + CHR$(34) +  "content=" + CHR$(34) + "text/html; charset=iso-8859-1" + CHR$(34) + ">"
   PRINT #2,"<meta name=" + CHR$(34) + "description" + CHR$(34) + " content=" + CHR$(34) + Beschreibung$ + CHR$(34) + ">"
   PRINT #2,"<meta name=" + CHR$(34) + "language" + CHR$(34) + " content=" + CHR$(34) + "de" + CHR$(34) + ">"
   PRINT #2,"<meta name=" + CHR$(34) + "homepage" + CHR$(34) + " content=" + CHR$(34) + "http://www.computus.de/" + CHR$(34) + ">"
   PRINT #2,"</head>"
   PRINT #2,"<body bgcolor=" + CHR$(34) + "#FFFFFF" + CHR$(34) + ">"
END SUB

SUB HTMLFeiertage(JD&, Tag%, Monat%, Jahr&, wt%, a$, rot%)
 a$ = "": rot% = 0

 IF (SchiKa2& AND 2 ^ 1) = 2 ^ 1 THEN
   Modus% = 1
   'Besondere Tage
   CALL FeiertagOsternG (JD&, Tag%, Monat%, Jahr&, "", NOText$, 0)
   IF NOText$ <> "" THEN a$ = a$ + NOText$
   CALL FeiertagAdventG (JD&, Jahr&, "", NAText$, 0)
   IF NAText$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + NAText$
   END IF

   'Feiertage an einem bestimmten Wochentag
   CALL WotaImMonat(DN_WOTAGMON$, JD&, Tag%, Monat%, Jahr&, WFText$, Farbe%)
   IF WFText$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + WFText$
     IF Farbe% = %rot THEN rot% = 1
   END IF

   'Sonstige Feiertage
   CALL FeiertagGreg(JD&, Tag%, Monat%, Jahr&, FGText$, "")
   IF FGText$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + FGText$: rot% = 1
   END IF

   CALL FeiertagOsternG (JD&, Tag%, Monat%, Jahr&, FOText$, "", 0)
   IF FOText$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + FOText$: rot% = 1
   END IF

   CALL FeiertagAdventG (JD&, Jahr&, FAText$, "", 0)
   IF FAText$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + FAText$: rot% = 1
   END IF

 END IF

 'J&uuml;dische Feiertage
 IF (SchiKa&& AND 2 ^ 52) = 2 ^ 52 THEN
   Modus% = 1
   CALL JultageJuddatum (JD&, JuTag%, JuMonat%, JuJahr&, JL%)
   CALL FeiertagJued (JuTag%, JuMonat%, wt%, JL%, FTJud$)
   IF FTJud$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "J&uuml;disch: " + FTJud$
   END IF
 END IF

 'Orthodoxe Feiertage
 IF (SchiKa&& AND 2 ^ 38) = 2 ^ 38 THEN
   Modus% = 1
   CALL JultageJuldatum (JD&, JTag%, JMonat%, JJahr&)
   CALL FeiertagOsternJ (JD&, JTag%, JMonat%, JJahr&, FTOJul$)
   IF FTOJul$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "Orthodox: " + FTOJul$
   END IF

   CALL FeiertagOrth (JTag%, JMonat%, FTNJul$)
   IF FTNJul$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "Orthodox: " + FTNJul$
   END IF

   CALL FeiertagAdventJ (JD&, JJahr&, FTAJul$, Diff&)
   IF FTAJul$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "Orthodox: " + FTAJul$
   END IF
 END IF

 'Koptischen Feiertage
 IF (SchiKa&& AND 2 ^ 36) = 2 ^ 36 THEN
   Modus% = 1
   CALL JultageJuldatum (JD&, JTag%, JMonat%, JJahr&)
   CALL FeiertagOsternK (JD&, JTag%, JMonat%, JJahr&, FTOKop$)
   IF FTOKop$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "Koptisch: " + FTOKop$
   END IF

   CALL JultageKoptdatum (JD&, KTag%, KMonat%, KJahr&)
   CALL FeiertagKopt (KTag%, KMonat%, FTNKop$)
   IF FTNKop$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "Koptisch: " + FTNKop$
   END IF
 END IF

  'Mohammedanische Feiertage
 IF (SchiKa&& AND 2 ^ 35) = 2 ^ 35 THEN
   Modus% = 1
   CALL JultageMoham (JD&, MTag%, MMonat%, MJahr&)
   CALL FeiertagIslam (MTag%, MMonat%, FTMoham$)
   IF FTMoham$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "Islamisch: " + FTMoham$
   END IF
 END IF

  'Chinesische Feiertage
 IF (SchiKa&& AND 2 ^ 44) = 2 ^ 44 THEN
   Modus% = 1
   CALL JultageChinesisch(JD&, ChTag%, ChMonat%, ZyklusJahr%, Zyklus%, TierJahr%, ErdeJahr%, TierTag%, ErdeTag%)
   CALL FeiertagChin (ChTag%, ChMonat%, FTChin$)
   IF FTChin$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "Chinesisch: " + FTChin$
   END IF
 END IF

 'Badi Feiertage
 IF (SchiKa2& AND 2 ^ 3) = 2 ^ 3 THEN
   Modus% = 1
   CALL JultageBadidatum (JD&, BaTag%, BaMonat%, BaJahr&, Vahid%, Kull%)
   CALL FeiertagBadi (BaTag%, BaMonat%, FTBadi$)
   IF FTBadi$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "Badi Baha'i: " + FTBadi$
   END IF
 END IF

 'DDR Feiertage
 IF (SchiKa2& AND 2 ^ 4) = 2 ^ 4 THEN
   Modus% = 1
   CALL FeiertagDDR(Tag%, Monat%, FTDDR$, fa&)
   IF FTDDR$ <> "" THEN
     IF a$ <> "" THEN a$ = a$ + "<br>"
     a$ = a$ + "DDR: " + FTDDR$
   END IF
 END IF

 IF a$ <> "" THEN CALL Umlaute_nach_HTML(a$)
 IF Modus% = 1 AND a$ = "" THEN a$ = "&nbsp;"
END SUB














